defint SbarPos = 50
defint SbarMin = 1
defint SbarMax = 100

create f as form
  width=150: height=250
  caption = "HotBars 1.0"
  icon="hotbasic.ico"
  create tbar as trackbar
    vertical=true
    left=10: top=10
    width=30: height=200
    range=SbarMin,SbarMax
    position=50
    color=&Hddddff
    onclick=tbar_pos
  end create
  create sbar as scrollbar
    vertical=true
    left=50: top=10
    width=16: height=200
    range=SbarMin,SbarMax
    position=SbarPos
    color=&Hddddff
    onclick=sbar_pos
  end create
  showmodal
end create

END

tbar_pos:
if nCode=8 then sound 900,100
return

sbar_pos:
select case nCode
case 0: DEC(SbarPos)
case 1: INC(SbarPos)
case 2: DEC(SbarPos,10)
case 3: INC(SbarPos,10)
case 4: SbarPos=lParam
case else: return
end select
IF SbarPos<SbarMin THEN SbarPos=SbarMin
IF SbarPos>SbarMax THEN SbarPos=SbarMax
sbar.Position=SbarPos
sound 800,100
return
