'CPUReg.inc Copyright 2008 James J Keene
'updated: Aug 6, 2008

'GetCPUReg populates the following variables
'with current CPU register values

defint V_eax,V_ebx,V_ecx,V_edx
defint V_esi,V_edi,V_ebp,V_esp

'PrtCPUReg prints the values

declare sub GetCPUReg
declare sub PrtCPUReg

sub GetCPUReg
ASM mov V_eax,eax: ASM mov V_ebx,ebx
ASM mov V_ecx,ecx: ASM mov V_edx,edx
ASM mov V_esi,esi: ASM mov V_edi,edi
ASM mov V_ebp,ebp: ASM mov V_esp,esp
end sub

sub PrtCPUReg
GetCPUReg
PRINT "eax "; hex$(V_eax); " ecx "; hex$(V_ecx);
PRINT " esi "; hex$(V_esi); " ebp "; hex$(V_ebp)
PRINT "ebx "; hex$(V_ebx); " edx "; hex$(V_edx);
PRINT " edi "; hex$(V_edi); " esp "; hex$(V_esp)
end sub

