'DXDraw.inc Copyright 2004 James J Keene
'Updated: Mar 31, 2007

OBJECT DXDRAW
DDObj As LONG
DDSurface As LONG
DDSurface2 As LONG
'DDSURFACEDESC offset=12
sSize As LONG = 108
Flags As LONG = 33  '&H21 = DDSD_CAPS + DDSD_BACKBUFFERCOUNT
sHeight As LONG  '= 640
sWidth As LONG  '= 480
Pitch As LONG
BackBufferCount As LONG '= 1  'two surface flipping
MipMapCount As LONG  'ZBufferBitDepth,RefreshRate
AlphaBitDepth As LONG
sReserved As LONG
lpSurface As LONG
DestOverlay_Low AS LONG  'DDCOLORKEY
DestOverlay_High AS LONG
DestBlt_Low AS LONG  'DDCOLORKEY
DestBlt_High AS LONG
SrcOverlay_Low AS LONG  'DDCOLORKEY
SrcOverlay_High AS LONG
SrcBlt_Low AS LONG  'DDCOLORKEY
SrcBlt_High AS LONG
pfSize AS LONG = 32 'DDPIXELFORMAT
pfFlags AS LONG
pfFourCC AS LONG
pfRGBBitCount AS LONG 'R/G/B BitMask
pfRBitMask As LONG
pfGBitMask As LONG
pfBBitMask As LONG
pfRGBAlphaBitMask AS LONG
Caps AS LONG = 536  '&H218 = DDSCAPS_COMPLEX + DDSCAPS_FLIP + DDSCAPS_PRIMARYSURFACE

DDCreate As SUB  'Create IDirectDraw
'DDraw methods
DDAddRef As FUNCTION
DDRelease As FUNCTION
DDCompact As SUB
DDCreateClipper As SUB
DDCreatePalette As SUB
DDCreateSurface As SUB
DDDuplicateSurface As SUB
DDEnumDisplayModes As SUB
DDEnumSurfaces As SUB
DDFlipToGDISurface As SUB
DDGetCaps As SUB
DDGetDisplayMode As SUB
DDGetFourCCCodes As SUB
DDGetGDISurface As SUB
DDGetMonitorFrequency As SUB
DDGetScanLine As SUB
DDGetVerticalBlankStatus As SUB
DDInitialize As SUB
DDRestoreDisplayMode As SUB
DDSetCooperativeLevel As SUB
DDSetDisplayMode As SUB
DDWaitForVerticalBlank As SUB
DDGetAvailableVidMem As SUB
'DDGetSurfaceFromDC As SUB
'DDRestoreAllSurfaces As SUB
'DDTestCooperativeLevel As SUB
'DDGetDeviceIdentifier As SUB
'DDStartModeTest As SUB
'DDEvaluateMode As SUB
'DDSurface
DDSQueryInterface As FUNCTION
DDSAddRef As FUNCTION
DDSRelease As FUNCTION
DDSAddAttachedSurface As SUB
DDSAddOverlayDirtyRect As SUB
DDSBlt As SUB
DDSBltBatch As SUB
DDSBltFast As SUB
DDSDeleteAttachedSurface As SUB
DDSEnumAttachedSurfaces As SUB
DDSEnumOverlayZOrders As SUB
DDSFlip As SUB
DDSGetAttachedSurface As SUB
DDSGetBltStatus As SUB
DDSGetCaps As SUB
DDSGetClipper As SUB
DDSGetColorKey As SUB
DDSGetDC As SUB
DDSGetFlipStatus As SUB
DDSGetOverlayPosition As SUB
DDSGetPalette As SUB
DDSGetPixelFormat As SUB
DDSGetSurfaceDesc As SUB
DDSInitialize As SUB
DDSIsLost As SUB
DDSLock As SUB
DDSReleaseDC As SUB
DDSRestore As SUB
DDSSetClipper As SUB
DDSSetColorKey As SUB
DDSSetOverlayPosition As SUB
DDSSetPalette As SUB
DDSUnlock As SUB
DDSUpdateOverlay As SUB
DDSUpdateOverlayDisplay As SUB
DDSUpdateOverlayZOrder As SUB
DDS2GetDDInterface As SUB
DDS2PageLock As SUB
DDS2PageUnlock As SUB
DDS3SetSurfaceDesc As SUB
DDS4SetPrivateData As SUB
DDS4GetPrivateData As SUB
DDS4FreePrivateData As SUB
DDS4GetUniquenessValue As SUB
DDS4ChangeUniquenessValue As SUB

END DXDRAW

deflng ddRET,ddFUN,ddADD
deflng dd0,dds0

'DXDRAW Object Declares
Declare FUNCTION DirectDrawCreate LIB "ddraw" _
  (lpGUID as LONG, lplpDD as LONG, pUnkOuter As LONG) as LONG

'utility functions
Declare SUB DDCreate
Declare FUNCTION ComFuncAddress AS LONG
Declare SUB DDRunTimeError(err$ As STRING)

'DDraw Object methods
Declare FUNCTION DDQueryInterface (iid AS STRING, ppvObj AS LONG) AS LONG
Declare FUNCTION DDAddRef As LONG
Declare FUNCTION DDRelease As LONG
Declare SUB DDCompact
Declare SUB DDCreateClipper _
  (Flags As LONG, lplpDDClipper As LONG, pUnkOuter As LONG)
Declare SUB DDCreatePalette _
  (Flags As LONG, lpColorTable As LONG,_
  lplpDDPalette As LONG, pUnkOuter As LONG)
Declare SUB DDCreateSurface _
  (lpDDSD As LONG, lplpDDSurface As LONG, pUnkOuter As LONG)
Declare SUB DDDuplicateSurface _
  (lpDDSurface As LONG, lplpDupDDSurface As LONG)
Declare SUB DDEnumDisplayModes _
  (Flags As LONG, lpDDSD As LONG, lpContext As LONG,_
  lpEnumModesCallback As LONG)
Declare SUB DDEnumSurfaces _
  (Flags As LONG, lpDDSD As LONG, lpContext As LONG,_
  lpEnumCallback As LONG)
Declare SUB DDFlipToGDISurface
Declare SUB DDGetCaps (lpDDDriverCaps As LONG, lpDDHELCaps As LONG)
Declare SUB DDGetDisplayMode (lpDDSD As LONG)
Declare SUB DDGetFourCCCodes (lpNumCodes As LONG, lpCodes As LONG)
Declare SUB DDGetGDISurface (lplpGDIDDSSurface As LONG)
Declare SUB DDGetMonitorFrequency (lpFrequency As LONG)
Declare SUB DDGetScanLine (lpScanLine As LONG)
Declare SUB DDGetVerticalBlankStatus (lpbIsInVB As LONG)
Declare SUB DDInitialize (lpGUID As LONG)
Declare SUB DDRestoreDisplayMode
Declare SUB DDSetCooperativeLevel (hwnd As LONG, Flags As LONG)
Declare SUB DDSetDisplayMode (Width AS LONG, Height AS LONG,_
  BPP AS LONG, RefreshRate As LONG, Flags As LONG)
Declare SUB DDWaitForVerticalBlank (Flags As LONG, hEvent As LONG)
Declare SUB DDGetAvailableVidMem _
  (lpDDSCaps As LONG, lpTotal As LONG, lpFree As LONG)
'Declare SUB DDGetSurfaceFromDC (hdc As LONG, lpDDS As LONG)
'Declare SUB DDRestoreAllSurfaces
'Declare SUB DDTestCooperativeLevel
'Declare SUB DDGetDeviceIdentifier (lpdddi As LONG, Flags As LONG)
'Declare SUB DDStartModeTest _
'  (ModesToTest As LONG, NumEntries As LONG, Flags As LONG)
'Declare SUB DDEvaluateMode _
'  (Flags As LONG, lpSecondsUntilTimeout As LONG)

'DDSurface methods
Declare FUNCTION DDSQueryInterface (iid AS STRING, ppvObj AS LONG) AS LONG
Declare FUNCTION DDSAddRef As LONG
Declare FUNCTION DDSRelease As LONG
Declare SUB DDSAddAttachedSurface (lpDDSAttachedSurface AS LONG)
Declare SUB DDSAddOverlayDirtyRect (lpRect AS LONG)
Declare SUB DDSBlt (lpDestRect AS LONG, lpDDSrcSurface AS LONG,_
  lpSrcRect AS LONG, Flags As LONG, lpDDBltFx AS LONG)
Declare SUB DDSBltBatch (lpDDBltBatch AS LONG, Count AS LONG, Flags AS LONG)
Declare SUB DDSBltFast (X AS LONG, Y AS LONG, lpDDSrcSurface AS LONG,_
  lpSrcRect AS LONG, Trans AS LONG)
Declare SUB DDSDeleteAttachedSurface (Flags AS LONG, lpDDSAttachedSurface AS LONG)
Declare SUB DDSEnumAttachedSurfaces _
  (lpContext AS LONG, lpEnumSurfacesCallback AS LONG)
Declare SUB DDSEnumOverlayZOrders  (Flags AS LONG, lpContext AS LONG, lpfnCallback AS LONG)
Declare SUB DDSFlip (lpDDSurfaceTargetOverride AS LONG, Flags AS LONG)
Declare SUB DDSGetAttachedSurface (lpDDSCaps AS LONG, lplpDDAttachedSurface AS LONG)
Declare SUB DDSGetBltStatus (Flags AS LONG)
Declare SUB DDSGetCaps (lpDDSCaps AS LONG)
Declare SUB DDSGetClipper (lplpDDClipper AS LONG)
Declare SUB DDSGetColorKey (Flags AS LONG, lpDDColorKey AS LONG)
Declare SUB DDSGetDC (lphDC As LONG)
Declare SUB DDSGetFlipStatus (Flags AS LONG)
Declare SUB DDSGetOverlayPosition (lplX AS LONG, lplY  AS LONG)
Declare SUB DDSGetPalette (lplpDDPalette AS LONG)
Declare SUB DDSGetPixelFormat (lpDDPixelFormat AS LONG)
Declare SUB DDSGetSurfaceDesc (lpDDSD AS LONG)
Declare SUB DDSInitialize (lpDD AS LONG, lpDDSD AS LONG)
Declare SUB DDSIsLost
Declare SUB DDSLock (lpDestRect AS LONG, lpDDSD AS LONG,_
  Flags AS LONG, hEvent AS LONG)
Declare SUB DDSReleaseDC (hDC AS LONG)
Declare SUB DDSRestore
Declare SUB DDSSetClipper (lpDDClipper AS LONG)
Declare SUB DDSSetColorKey (Flags AS LONG, lpDDColorKey AS LONG)
Declare SUB DDSSetOverlayPosition (lX AS LONG, lY AS LONG)
Declare SUB DDSSetPalette (lpDDPalette AS LONG)
Declare SUB DDSUnlock (lpSurfaceData AS LONG)
Declare SUB DDSUpdateOverlay (lpSrcRect AS LONG, lpDDDestSurface AS LONG,_
  lpDestRect AS LONG, Flags AS LONG, lpDDOverlayFx AS LONG)
Declare SUB DDSUpdateOverlayDisplay (Flags AS LONG)
Declare SUB DDSUpdateOverlayZOrder (Flags AS LONG, lpDDSReference AS LONG)
Declare SUB DDS2GetDDInterface (lplpDD AS LONG)
Declare SUB DDS2PageLock (Flags AS LONG)
Declare SUB DDS2PageUnlock (Flags AS LONG)
Declare SUB DDS3SetSurfaceDesc (lpDDSD  AS LONG, Flags AS LONG)
Declare SUB DDS4SetPrivateData _
  (guidTag AS LONG, lpData AS LONG, Size AS LONG, Flags AS LONG)
Declare SUB DDS4GetPrivateData _
  (guidTag  AS LONG, lpData AS LONG, lpSize AS LONG)
Declare SUB DDS4FreePrivateData (guidTag AS LONG)
Declare SUB DDS4GetUniquenessValue (lpValue AS LONG)
Declare SUB DDS4ChangeUniquenessValue

'utility functions
FUNCTION ComFuncAddress AS LONG
INC(ddADD,4): RESULT=BYREF(ddADD)
END FUNCTION

SUB DDRunTimeError(err$ As STRING)
ShowMessage err$+" error "+hex$(ddRET): App.Terminate
END SUB

'DXDRAW Object method setup
SUB DDCreate
ddRET=DirectDrawCreate(zero,hbObj,zero)
IF ddRET THEN DDRunTimeError("DirectDrawCreate")
dd0=BYREF(hbObj): ddADD=BYREF(dd0)-4
$OPTION DIM LONG
CONST aDDQueryInterface = ComFuncAddress
CONST aDDAddRef = ComFuncAddress  '4
CONST aDDRelease = ComFuncAddress  '8
CONST aDDCompact = ComFuncAddress  '12
CONST aDDCreateClipper = ComFuncAddress  '16
CONST aDDCreatePalette = ComFuncAddress  '20
CONST aDDCreateSurface = ComFuncAddress  '24
CONST aDDDuplicateSurface = ComFuncAddress  '28
CONST aDDEnumDisplayModes = ComFuncAddress  '32
CONST aDDEnumSurfaces = ComFuncAddress  '36
CONST aDDFlipToGDISurface = ComFuncAddress  '40
CONST aDDGetCaps = ComFuncAddress  '44
CONST aDDGetDisplayMode = ComFuncAddress  '48
CONST aDDGetFourCCCodes = ComFuncAddress  '52
CONST aDDGetGDISurface = ComFuncAddress  '56
CONST aDDGetMonitorFrequency = ComFuncAddress  '60
CONST aDDGetScanLine = ComFuncAddress  '64
CONST aDDGetVerticalBlankStatus = ComFuncAddress  '68
CONST aDDInitialize = ComFuncAddress  '72
CONST aDDRestoreDisplayMode = ComFuncAddress  '76
CONST aDDSetCooperativeLevel = ComFuncAddress  '80
CONST aDDSetDisplayMode = ComFuncAddress  '84
CONST aDDWaitForVerticalBlank = ComFuncAddress  '88
CONST aDDGetAvailableVidMem = ComFuncAddress  '92
'CONST aDDGetSurfaceFromDC = ComFuncAddress  '96
'CONST aDDRestoreAllSurfaces = ComFuncAddress  '100
'CONST aDDTestCooperativeLevel = ComFuncAddress  '104
'CONST aDDGetDeviceIdentifier = ComFuncAddress  '108
'CONST aDDStartModeTest = ComFuncAddress  '112
'CONST aDDEvaluateMode = ComFuncAddress  '116
END SUB

'DD methods
FUNCTION DDAddRef As LONG
CALLFUNC aDDAddRef,dd0
result=RETFUNC
END FUNCTION

FUNCTION DDRelease As LONG
CALLFUNC aDDRelease,dd0
result=RETFUNC
END FUNCTION

SUB DDCompact
CALLFUNC aDDCompact,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDCompact")
END SUB

SUB DDCreateClipper _
  (Flags As LONG, lplpDDClipper As LONG, pUnkOuter As LONG)
CALLFUNC aDDCreateClipper,pUnkOuter,lplpDDClipper,Flags,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDCreateClipper")
'set up methods here
END SUB

SUB DDCreatePalette _
  (Flags As LONG, lpColorTable As LONG,_
  lplpDDPalette As LONG, pUnkOuter As LONG)
CALLFUNC aDDCreatePalette,pUnkOuter,lplpDDPalette,lpColorTable,Flags,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDCreatePalette")
'set up methods here
END SUB

SUB DDCreateSurface _
  (lpDDSD As LONG, lplpDDSurface As LONG, pUnkOuter As LONG)
CALLFUNC aDDCreateSurface,pUnkOuter,lplpDDSurface,lpDDSD,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDCreateSurface")
dds0=BYREF(lplpDDSurface): ddADD=BYREF(dds0)-4
CONST aDDSQueryInterface = ComFuncAddress
CONST aDDSAddRef = ComFuncAddress  '4
CONST aDDSRelease = ComFuncAddress  '8
CONST aDDSAddAttachedSurface = ComFuncAddress  '12
CONST aDDSAddOverlayDirtyRect = ComFuncAddress  '16
CONST aDDSBlt = ComFuncAddress  '20
CONST aDDSBltBatch = ComFuncAddress  '24
CONST aDDSBltFast = ComFuncAddress  '28
CONST aDDSDeleteAttachedSurface = ComFuncAddress  '32
CONST aDDSEnumAttachedSurfaces = ComFuncAddress  '36
CONST aDDSEnumOverlayZOrders = ComFuncAddress  '40
CONST aDDSFlip = ComFuncAddress  '44
CONST aDDSGetAttachedSurface = ComFuncAddress  '48
CONST aDDSGetBltStatus = ComFuncAddress  '52
CONST aDDSGetCaps = ComFuncAddress  '56
CONST aDDSGetClipper = ComFuncAddress  '60
CONST aDDSGetColorKey = ComFuncAddress  '64
CONST aDDSGetDC = ComFuncAddress  '68
CONST aDDSGetFlipStatus = ComFuncAddress  '72
CONST aDDSGetOverlayPosition = ComFuncAddress  '76
CONST aDDSGetPalette = ComFuncAddress  '80
CONST aDDSGetPixelFormat = ComFuncAddress  '84
CONST aDDSGetSurfaceDesc = ComFuncAddress  '88
CONST aDDSInitialize = ComFuncAddress  '92
CONST aDDSIsLost = ComFuncAddress  '96
CONST aDDSLock = ComFuncAddress  '100
CONST aDDSReleaseDC = ComFuncAddress  '104
CONST aDDSRestore = ComFuncAddress  '108
CONST aDDSSetClipper = ComFuncAddress  '112
CONST aDDSSetColorKey = ComFuncAddress  '116
CONST aDDSSetOverlayPosition  = ComFuncAddress  '120
CONST aDDSSetPalette = ComFuncAddress  '124
CONST aDDSUnlock = ComFuncAddress  '128
CONST aDDSUpdateOverlay = ComFuncAddress  '132
CONST aDDSUpdateOverlayDisplay = ComFuncAddress  '136
CONST aDDSUpdateOverlayZOrder = ComFuncAddress  '140
CONST aDDS2GetDDInterface = ComFuncAddress  '144
CONST aDDS2PageLock = ComFuncAddress  '148
CONST aDDS2PageUnlock = ComFuncAddress  '152
CONST aDDS3SetSurfaceDesc = ComFuncAddress  '156
CONST aDDS4SetPrivateData = ComFuncAddress  '160
CONST aDDS4GetPrivateData = ComFuncAddress  '164
CONST aDDS4FreePrivateData = ComFuncAddress  '168
CONST aDDS4GetUniquenessValue = ComFuncAddress  '172
CONST aDDS4ChangeUniquenessValue = ComFuncAddress  '176
END SUB

SUB DDDuplicateSurface _
  (lpDDSurface As LONG, lplpDupDDSurface As LONG)
CALLFUNC aDDDuplicateSurface,lplpDupDDSurface,lpDDSurface,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDDuplicateSurface")
END SUB

SUB DDEnumDisplayModes _
  (Flags As LONG, lpDDSD As LONG, lpContext As LONG,_
  lpEnumModesCallback As LONG)
CALLFUNC aDDEnumDisplayModes,lpEnumModesCallback,lpContext,lpDDSD,Flags,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDEnumDisplayModes")
END SUB

SUB DDEnumSurfaces _
  (Flags As LONG, lpDDSD As LONG, lpContext As LONG,_
  lpEnumCallback As LONG)
CALLFUNC aDDEnumSurfaces,lpEnumCallback,lpContext,lpDDSD,Flags,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDEnumSurfaces")
END SUB

SUB DDFlipToGDISurface
CALLFUNC aDDFlipToGDISurface,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDFlipToGDISurface")
END SUB

SUB DDGetCaps (lpDDDriverCaps As LONG, lpDDHELCaps As LONG)
CALLFUNC aDDGetCaps,lpDDHELCaps,lpDDDriverCaps,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetCaps")
END SUB

SUB DDGetDisplayMode (lpDDSD As LONG)
CALLFUNC aDDGetDisplayMode,lpDDSD,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetDisplayMode")
END SUB

SUB DDGetFourCCCodes _
  (lpNumCodes As LONG, lpCodes As LONG) As LONG
CALLFUNC aDDGetFourCCCodes,lpCodes,lpNumCodes,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("GetFourCCCodes")
END SUB

SUB DDGetGDISurface _
  (lplpGDIDDSSurface As LONG) As LONG
CALLFUNC aDDGetGDISurface,lplpGDIDDSSurface,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetGDISurface")
END SUB

SUB DDGetMonitorFrequency _
  (lpFrequency As LONG) As LONG
CALLFUNC aDDGetMonitorFrequency,lpFrequency,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetMonitorFrequency")
END SUB

SUB DDGetScanLine _
  (lpScanLine As LONG) As LONG
CALLFUNC aDDGetScanLine,lpScanLine,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetScanLine")
END SUB

SUB DDGetVerticalBlankStatus (lpbIsInVB As LONG) As LONG
CALLFUNC aDDGetVerticalBlankStatus,lpbIsInVB,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetVerticalBlankStatus")
END SUB

SUB DDInitialize (lpGUID As LONG) As LONG
CALLFUNC aDDInitialize,lpGUID,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDInitialize")
END SUB

SUB DDRestoreDisplayMode As LONG
CALLFUNC aDDRestoreDisplayMode,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDRestoreDisplayMode")
END SUB

SUB DDSetCooperativeLevel (hwnd As LONG, Flags As LONG) As LONG
CALLFUNC aDDSetCooperativeLevel,Flags,hwnd,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSetCooperativeLevel")
END SUB

SUB DDSetDisplayMode _
  (Width AS LONG, Height AS LONG, BPP AS LONG,_
  RefreshRate As LONG, Flags As LONG) As LONG
CALLFUNC aDDSetDisplayMode,Flags,RefreshRate,BPP,Height,Width,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSetDisplayMode")
END SUB

SUB DDWaitForVerticalBlank _
  (Flags As LONG, hEvent As LONG) As LONG
CALLFUNC aDDWaitForVerticalBlank,hEvent,Flags,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDWaitForVerticalBlank")
END SUB

SUB DDGetAvailableVidMem _
  (lpDDSCaps As LONG, lpTotal As LONG, lpFree As LONG) As LONG
CALLFUNC aDDGetAvailableVidMem,lpFree,lpTotal,lpDDSCaps,dd0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDGetAvailableVidMem")
END SUB

'DDSurface methods
'Declare FUNCTION DDSQueryInterface (iid AS STRING, ppvObj AS LONG) AS LONG
FUNCTION DDSAddRef As LONG
CALLFUNC aDDSAddRef,dds0
result=RETFUNC
END FUNCTION

FUNCTION DDSRelease As LONG
CALLFUNC aDDSRelease,dds0
result=RETFUNC
END FUNCTION

SUB DDSAddAttachedSurface (lpDDSAttachedSurface AS LONG)
CALLFUNC aDDSAddAttachedSurface,lpDDSAttachedSurface,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSAddAttachedSurface")
END SUB

SUB DDSAddOverlayDirtyRect (lpRect AS LONG)
CALLFUNC aDDSAddOverlayDirtyRect,lpRect,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSAddOverlayDirtyRect")
END SUB

SUB DDSBlt (lpDestRect AS LONG, lpDDSrcSurface AS LONG,_
  lpSrcRect AS LONG, Flags As LONG, lpDDBltFx AS LONG)
CALLFUNC aDDSBlt,lpDDBltFx,Flags,lpSrcRect,lpDDSrcSurface,lpDestRect,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSBlt")
END SUB

SUB DDSBltBatch (lpDDBltBatch AS LONG, Count AS LONG, Flags AS LONG)
CALLFUNC aDDSBltBatch,Flags,Count,lpDDBltBatch,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSBltBatch")
END SUB

SUB DDSBltFast (X AS LONG, Y AS LONG, lpDDSrcSurface AS LONG,_
  lpSrcRect AS LONG, Trans AS LONG)
CALLFUNC aDDSBltFast,Trans,lpSrcRect,lpDDSrcSurface,Y,X,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSBltFast")
END SUB

SUB DDSDeleteAttachedSurface (Flags AS LONG, lpDDSAttachedSurface AS LONG)
CALLFUNC aDDSDeleteAttachedSurface,lpDDSAttachedSurface,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSDeleteAttachedSurface")
END SUB

SUB DDSEnumAttachedSurfaces _
  (lpContext AS LONG, lpEnumSurfacesCallback AS LONG)
CALLFUNC aDDSEnumAttachedSurfaces,lpEnumSurfacesCallback,lpContext,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSEnumAttachedSurfaces")
END SUB

SUB DDSEnumOverlayZOrders  (Flags AS LONG, lpContext AS LONG, lpfnCallback AS LONG)
CALLFUNC aDDSEnumOverlayZOrders,lpfnCallback,lpContext,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSEnumOverlayZOrders")
END SUB

SUB DDSFlip (lpDDSurfaceTargetOverride AS LONG, Flags AS LONG)
CALLFUNC aDDSFlip,Flags,lpDDSurfaceTargetOverride,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSFlip")
END SUB

SUB DDSGetAttachedSurface (lpDDSCaps AS LONG, lplpDDAttachedSurface AS LONG)
CALLFUNC aDDSGetAttachedSurface,lplpDDAttachedSurface,lpDDSCaps,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetAttachedSurface")
END SUB

SUB DDSGetBltStatus (Flags AS LONG)
CALLFUNC aDDSGetBltStatus,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetBltStatus")
END SUB

SUB DDSGetCaps (lpDDSCaps AS LONG)
CALLFUNC aDDSGetCaps,lpDDSCaps,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetCaps")
END SUB

SUB DDSGetClipper (lplpDDClipper AS LONG)
CALLFUNC aDDSGetClipper,lplpDDClipper,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetClipper")
END SUB

SUB DDSGetColorKey (Flags AS LONG, lpDDColorKey AS LONG)
CALLFUNC aDDSGetColorKey,lpDDColorKey,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetColorKey")
END SUB

SUB DDSGetDC (lphDC As LONG)
CALLFUNC aDDSGetDC,lphDC,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetDC")
END SUB

SUB DDSGetFlipStatus (Flags AS LONG)
CALLFUNC aDDSGetFlipStatus,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetFlipStatus")
END SUB

SUB DDSGetOverlayPosition (lplX AS LONG, lplY  AS LONG)
CALLFUNC aDDSGetOverlayPosition,lplY,lplX,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetOverlayPosition")
END SUB

SUB DDSGetPalette (lplpDDPalette AS LONG)
CALLFUNC aDDSGetPalette,lplpDDPalette,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetPalette")
END SUB

SUB DDSGetPixelFormat (lpDDPixelFormat AS LONG)
CALLFUNC aDDSGetPixelFormat,lpDDPixelFormat,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetPixelFormat")
END SUB

SUB DDSGetSurfaceDesc (lpDDSD AS LONG)
CALLFUNC aDDSGetSurfaceDesc,lpDDSD,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSGetSurfaceDesc")
END SUB

SUB DDSInitialize (lpDD AS LONG, lpDDSD AS LONG)
CALLFUNC aDDSInitialize,lpDDSD,lpDD,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSInitialize")
END SUB

SUB DDSIsLost
CALLFUNC aDDSIsLost,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSIsLost")
END SUB

SUB DDSLock (lpDestRect AS LONG, lpDDSD AS LONG,_
  Flags AS LONG, hEvent AS LONG)
CALLFUNC aDDSLock,hEvent,Flags,lpDDSD,lpDestRect,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSLock")
END SUB

SUB DDSReleaseDC (hDC AS LONG)
CALLFUNC aDDSReleaseDC,hDC,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSReleaseDC")
END SUB

SUB DDSRestore
CALLFUNC aDDSRestore,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSRestore")
END SUB

SUB DDSSetClipper (lpDDClipper AS LONG)
CALLFUNC aDDSSetClipper,lpDDClipper,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSSetClipper")
END SUB

SUB DDSSetColorKey (Flags AS LONG, lpDDColorKey AS LONG)
CALLFUNC aDDSSetColorKey,lpDDColorKey,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSSetColorKey")
END SUB

SUB DDSSetOverlayPosition (lX AS LONG, lY AS LONG)
CALLFUNC aDDSSetOverlayPosition,lY,lX,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSSetOverlayPosition")
END SUB

SUB DDSSetPalette (lpDDPalette AS LONG)
CALLFUNC aDDSSetPalette,lpDDPalette,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSSetPalette")
END SUB

SUB DDSUnlock (lpSurfaceData AS LONG)
CALLFUNC aDDSUnlock,lpSurfaceData,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSUnlock")
END SUB

SUB DDSUpdateOverlay (lpSrcRect AS LONG, lpDDDestSurface AS LONG,_
  lpDestRect AS LONG, Flags AS LONG, lpDDOverlayFx AS LONG)
CALLFUNC aDDSUpdateOverlay,lpDDOverlayFx,Flags,lpDestRect,lpDDDestSurface,lpSrcRect,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSUpdateOverlay")
END SUB

SUB DDSUpdateOverlayDisplay (Flags AS LONG)
CALLFUNC aDDSUpdateOverlayDisplay,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSUpdateOverlayDisplay")
END SUB

SUB DDSUpdateOverlayZOrder (Flags AS LONG, lpDDSReference AS LONG)
CALLFUNC aDDSUpdateOverlayZOrder,lpDDSReference,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDSUpdateOverlayZOrder")
END SUB

SUB DDS2GetDDInterface (lplpDD AS LONG)
CALLFUNC aDDS2GetDDInterface,lplpDD,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS2GetDDInterface")
END SUB

SUB DDS2PageLock (Flags AS LONG)
CALLFUNC aDDS2PageLock,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS2PageLock")
END SUB

SUB DDS2PageUnlock (Flags AS LONG)
CALLFUNC aDDS2PageUnlock,Flags,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS2PageUnlock")
END SUB

SUB DDS3SetSurfaceDesc (lpDDSD  AS LONG, Flags AS LONG)
CALLFUNC aDDS3SetSurfaceDesc,Flags,lpDDSD,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS3SetSurfaceDesc")
END SUB

SUB DDS4SetPrivateData _
  (guidTag AS LONG, lpData AS LONG, Size AS LONG, Flags AS LONG)
CALLFUNC aDDS4SetPrivateData,Flags,Size,lpData,guidTag,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS4SetPrivateData")
END SUB

SUB DDS4GetPrivateData _
  (guidTag  AS LONG, lpData AS LONG, lpSize AS LONG)
CALLFUNC aDDS4GetPrivateData,lpSize,lpData,guidTag,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS4GetPrivateData")
END SUB

SUB DDS4FreePrivateData (guidTag AS LONG)
CALLFUNC aDDS4FreePrivateData,guidTag,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS4FreePrivateData")
END SUB

SUB DDS4GetUniquenessValue (lpValue AS LONG)
CALLFUNC aDDS4GetUniquenessValue,lpValue,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS4GetUniquenessValue")
END SUB

SUB DDS4ChangeUniquenessValue
CALLFUNC aDDS4ChangeUniquenessValue,dds0
ddRET=RETFUNC
IF ddRET THEN DDRunTimeError("DDS4ChangeUniquenessValue")
END SUB
