$APPTYPE GUI: $TYPECHECK ON
$INCLUDE "DxDraw.inc"

'array offsets for DDSurfaceDesc
$DEFINE DDSD_size 0
$DEFINE Flags 1
$DEFINE sHeight 2
$DEFINE sWidth 3
$DEFINE BackBufferCount 5
$DEFINE PF_size 18
$DEFINE RGBBitCount 21
$DEFINE Caps 26

showconsole
'scratch DirectX "type structures" and pointers
DIM DX1(63) As DWORD, DX2(63) As DWORD
DEFDWORD aDX1=@DX1
DEFDWORD aDX2=@DX2
DEFDWORD i,j
DEFINT cWidth,cHeight

DIM form As FORM
form.icon="hotbasic.ico"
form.caption="HotBasic(tm) DxDraw 1.30"
cWidth=form.clientwidth
cHeight=form.clientheight

DIM dxs AS CANVAS  'DirectX surface
dxs.left=0: dxs.top=0: dxs.width=cWidth: dxs.height=cHeight
dxs.OnPaint=dxs_paint

' use current GDI drawing surface
DIM dxd as DXDRAW
dxd.DDCreate
DX1(DDSD_size)=108
DX1(PF_size)=32

SELECT CASE 3 'set to test each Scenario
CASE 1  'Scenario 1:
dxd.DDSetCooperativeLevel(form,17)  'DDSCL_FULLSCREEN,EXCLUSIVE
DX1(Flags)=1  'DDSD_CAPS
DX1(Caps)=&H200  'DDSCAPS_primarysurface

CASE 2  'Scenario 2:
dxd.DDSetCooperativeLevel(dxs,8)  'DDSCL_NORMAL
DX1(Flags)=7  'DDSD_CAPS,WIDTH,HEIGHT
DX1(Caps)=&H40  'DDSCAPS_offscreenplain
DX1(sHeight)=cHeight
DX1(sWidth)=cWidth

CASE 3  'Scenario 3:
dxd.DDSetCooperativeLevel(form,17)  'DDSCL_FULLSCREEN,EXCLUSIVE
DX1(Flags)=&H21  'DDSD_CAPS,BACKBUFFERCOUNT
DX1(Caps)=&H218  'DDSCAPS_COMPLEX,FLIP,PRIMARYSURFACE
DX1(BackBufferCount)=1
END SELECT

dxd.DDCreateSurface(aDX1,@i,0)
gosub print_surface

DX1(0)=108  'size of DDSurfaceDesc
dxd.DDGetDisplayMode(aDX1)  'lpDDSurfaceDesc
gosub print_surface

form.ShowModal
END

dxs_paint:
dxs.Rectangle 10,10,100,100,0
dxs.Paint 12,12,&HFF,0
return

print_surface:
print hex$(i)
PRINT "Display width  = ";DX1(sWidth)
PRINT "Display height = ";DX1(sHeight)
PRINT "Display color  = ";DX1(RGBBitCount)
return
