'FindForm.inc Copyright 2004 James J Keene
'Updated: Sep 8, 2004

'This form replaces the FINDDIALOG Object which
'is more difficult to implement in an application.

'Include this file after your main form is defined
'and before your FORM .showmodal.

'To display this Find Dialog, simply use
'find.visible=true: ftext.focus
'in your main program.

'Pressing enter in the "Find what" box or clicking
'"Find" runs your "do_find" routine, which can be
'written so that repeated calls are equivalent to
'a "find next" operation.  (e.g., HotIDE)

'The "find_hide" routine simply does this:
'find.visible=false: sc.focus 'set desired focus

create find as FORM
  ExStyle = find.ExStyle OR &H88  'tool & topmost
  Caption = "Find Text"
  Width = 200
  Height = 90
  Center
  Resizeable=false
  Visible=false
  Onclose=find_hide  'sub setting .visible=false
  create flab As LABEL
    Top=8
    Left=8
    Width=56
    Height=20
    Caption="Find what:"
  end create
  create ftext As EDIT
    Top=8
    Left=64
    Width=120
    Height=20
    OnKeyUp=ftext_key
  end create
  create fcase As CHECKBOX
    Top=40
    Left=8
    Width=80
    Height=20
    Caption="Match case"
  end create
  create fbut As BUTTON
    Top=40
    Left=130
    Width=50
    Height=20
    Caption="Find"
    OnClick=do_find  'user-written procedure
  end create
end create

Goto FindForm_End  'jump past this:

ftext_key:
IF wParam=13 THEN Goto do_find
IF wParam=27 THEN Goto find_hide
return

FindForm_End:
