'Format.inc Copyright 2006 James J Keene

'Usage: MyStr = Format(MyFloat,fStr)
'Example: MyStr = Format(x,"####.##")

DECLARE FUNCTION Format (fX as DOUBLE, fStr As STRING) As STRING 

FUNCTION Format 
begin runonce: defstr r: end runonce
defint i,j,k
'check if we need to round result
k=instr(fStr,".")
if instr(fStr,"0") then  'any "0" in pattern
  i=fStr.length-k
  r="."+string$(i,"0")+"5": INC(fX,val(r))
end if
r=STR$(fX): j=instr(r,".")
'check for leading . as in ".###"
if k=one then
  if j>zero then r=mid$(r,j) else r="."+r
  j=one
end if
'output has/does not have "." according to pattern
if k>zero and j=zero then r.writestr(".",1): j=r.length
if k=zero and j>zero then r=left$(r,j-1): j=zero
'set digits to right of "."
if k then  'true if pattern has "."
  'get digits to right of "."
  i=fStr.length-k  'for pattern
  k=r.length-j     'for output
  if k>i then r=left$(r,j+i)       'shorten output
  if i>k then r=r+string$(i-k,"0") 'lengthen output
end if
'set field length
i=fStr.length-r.length
if i>zero then r=space$(i)+r 
RESULT = r
END FUNCTION
