'hbarray.inc Copyright 2009 James J Keene
'updated: Feb 24, 2009

'The HBARRAY type should be included where
'the OBJPTR() to an array used to read/write
'arrays within USE/END USE blocks.

'The .type property is coded as follows:
'STRING-0, DOUBLE-1, SINGLE-2, REAL10-3
'LONG-4, BYTE-5, WORD-6, SHORT-7, DWORD-8, INT64-9

TYPE HBARRAY
loc as long   'ptr to array content/data
pos as long   'position
len as long   'length
siz as long   'size or .RAM property
han as long   'ram handle
dim as byte   'number of subscripts; offset 20
type as byte  'code for data type
zbd as word   'true if not 0-based ; offset 22
lbd1 as long  'lower bounds; offset 24
lbd2 as long
lbd3 as long
lbd4 as long
lbd5 as long
ubd1 as long  'upper bounds; offset 44
ubd2 as long
ubd3 as long
ubd4 as long
ubd5 as long
prd1 as long  'precalculated products
prd2 as long
prd3 as long
prd4 as long
prd5 as long
END HBARRAY
