'HBcolors.inc Copyright 2004-2007 James J Keene
'Updated: Feb 7, 2007

'Adds keyword colors to HotBasic source code line.
'$include "HBcolors.inc" for RichEd2 .HBcolors method.
'For speed, .HBcolors turns .ReDraw=false.
'Your code should set .ReDraw=true when appropriate.

DEFSTR HBchild,HBdim,HBdirec,HBnum,HBstate,HBstr,HBtypes
DEFSTR HBstr1,HBnum1

'This for keywords as resources:
$RESOURCE HB_CHILD as "inc\hotchild.lst"
$RESOURCE HB_DIM as "inc\hotdim.lst"
$RESOURCE HB_DIREC as "inc\hotdirec.lst"
$RESOURCE HB_NUM as "inc\hotnum.lst"
$RESOURCE HB_NUM1 as "inc\hotnum1.lst"
$RESOURCE HB_STATE as "inc\hotstate.lst"
$RESOURCE HB_STR as "inc\hotstr.lst"
$RESOURCE HB_STR1 as "inc\hotstr1.lst"
$RESOURCE HB_TYPES as "inc\hottypes.lst"

HBchild.ExtractRes "HB_CHILD"
HBdim.ExtractRes "HB_DIM"
HBdirec.ExtractRes "HB_DIREC"
HBnum.ExtractRes "HB_NUM"
HBnum1.ExtractRes "HB_NUM1"
HBstate.ExtractRes "HB_STATE"
HBstr.ExtractRes "HB_STR"
HBstr1.ExtractRes "HB_STR1"
HBtypes.ExtractRes "HB_TYPES"

DEFSTR HBany$ = " .:;()=-+><*/\^,?%&!#[]"+TAB

DIM HBCC(9) As LONG, iCC As LONG
HBCC(0)=zero
HBCC(1)=&HFF00FF 'pink
HBCC(2)=&H8000   'green
HBCC(3)=&HD050A0 'purple
HBCC(4)=&H3070E0 '4080E0 'orange
HBCC(5)=&HFF0000 'blue
HBCC(6)=&HD0A040 'light blue
HBCC(7)=&H50A000 'light green
HBCC(8)=&H8000FF 'red
HBCC(9)=&H80     'dark brown

DECLARE SUB HBcolors(re2LINE As LONG)

'''''
SUB HBcolors(re2LINE As LONG)
DEFSTR r$,k$,t$
DEFLNG CP,LP,Q,i,j,k,v1,v2

BYREF(hbObj+24)=&H40000000  '.MaskBits

t$=UCASE$(Item(re2LINE)): t$=RTRIM$(t$)
IF t$=null THEN Exit SUB

re2RET=sendmessage(hbHnd,11,zero,zero) '.ReDraw = false
CP=sendmessage(hbHnd,187,re2LINE,zero)  '.CharFromLine

LP=CP+t$.Length
re2RET=sendmessage(hbHnd,1079,zero,@CP)  '.SetSel
BYREF(hbObj+40)=zero  '.TextColor=0
SetCharFormat

i=1: Q=zero
IF LEFT$(t$,4)="REM " THEN Goto HBcomment

NextHBKey:
IF i>t$.Length THEN Exit SUB
r$=t$[i]
IF r$=quote THEN
  IF Q THEN
    Q=zero: v2=i: iCC=1: Goto HBColorize
  ELSE
    Q=1: v1=i: INC(i): Goto NextHBKey
  END IF
END IF
IF Q THEN INC(i): Goto NextHBKey
IF r$=space THEN INC(i): Goto NextHBKey
IF r$="'" THEN
  HBcomment:
  v1=i: v2=t$.Length: iCC=2: Goto HBColorize
END IF

v1=i
IF i<t$.length THEN
  v2=zero
  FOR k=1 to HBany$.Length
  r$=HBany$[k]
  j=INSTR(i,t$,r$)
  IF j THEN
    IF v2 THEN
      IF j<v2 THEN v2=j
    ELSE
      v2=j
    END IF
  END IF
  NEXT k
ELSE
  v2=i
END IF

IF not v2 THEN v2=t$.Length ELSE DEC(v2)
k$=mid$(t$,v1,one+v2-v1)

IF HBdim.IndexOf(k$)>=zero THEN iCC=3: Goto HBColorize
IF HBdirec.IndexOf(k$)>=zero THEN iCC=4: Goto HBColorize
IF HBstate.IndexOf(k$)>=zero THEN iCC=5: Goto HBColorize
IF HBnum.IndexOf(k$)>=zero THEN iCC=6: Goto HBColorize
IF HBnum1.IndexOf(k$)>=zero THEN iCC=6: Goto HBColorize
IF HBstr.IndexOf(k$)>=zero THEN iCC=7: Goto HBColorize
IF HBstr1.IndexOf(k$)>=zero THEN iCC=7: Goto HBColorize
IF HBtypes.IndexOf(k$)>=zero THEN iCC=8: Goto HBColorize
IF HBchild.IndexOf(k$)>=zero THEN iCC=9: Goto HBColorize
INC(v2): Goto inc_v2

HBColorize:
i=HBCC(iCC)
ASM mov esi,hbObj
ASM mov eax,HBcolorsv1
ASM add eax,HBcolorsCP
ASM dec eax
ASM mov [esi],eax ;start
ASM mov eax,HBcolorsv2
ASM add eax,HBcolorsCP
ASM mov [esi+4],eax ;end
re2RET=sendmessage(hbHnd,1079,zero,hbObj)  '.SetSel
ASM mov eax,HBcolorsi
ASM mov [esi+40],eax ;.TextColor
SetCharFormat

inc_v2:
INC(v2)
i=v2: Goto NextHBKey

END SUB
