'HBguidef.inc provides a summary of many GUI constants.
'Updated: Nov 21, 2004
'Copyright 2004 James J Keene
'Information provided by Microsoft Corporation.

'This file uses $DEFINE instead of CONST.  CONST defines a memory location
'with a value.  $DEFINE uses "text replacement" and leads to slightly
'shorter programs since source code references to constants are replaced
'with the numerical value.

'This file may be best used as a reference or selections can be cut and
'pasted into your source code.
'$INCLUDE of the entire file may be done, but compile time will increase.

'''''FORM'''''
'ExStyle bits
$DEFINE WS_EX_LEFT               &H0
$DEFINE WS_EX_LTRREADING         &H0
$DEFINE WS_EX_RIGHTSCROLLBAR     &H0
$DEFINE WS_EX_DLGMODALFRAME      &H1
$DEFINE WS_EX_NOPARENTNOTIFY     &H4
$DEFINE WS_EX_TOPMOST            &H8
$DEFINE WS_EX_ACCEPTFILES       &H10
$DEFINE WS_EX_TRANSPARENT       &H20
$DEFINE WS_EX_MDICHILD          &H40
$DEFINE WS_EX_TOOLWINDOW        &H80
$DEFINE WS_EX_WINDOWEDGE       &H100
$DEFINE WS_EX_PALETTEWINDOW    &H188
$DEFINE WS_EX_CLIENTEDGE       &H200
$DEFINE WS_EX_OVERLAPPEDWINDOW &H300
$DEFINE WS_EX_CONTEXTHELP      &H400
$DEFINE WS_EX_RIGHT           &H1000
$DEFINE WS_EX_RTLREADING      &H2000
$DEFINE WS_EX_LEFTSCROLLBAR   &H4000
$DEFINE WS_EX_CONTROLPARENT  &H10000
$DEFINE WS_EX_STATICEDGE     &H20000
$DEFINE WS_EX_APPWINDOW      &H40000
$DEFINE WS_EX_BACKWARDS     &H400000

'Style bits
$DEFINE WS_OVERLAPPED         &H0
$DEFINE WS_TILED              &H0
$DEFINE WS_MAXIMIZEBOX    &H10000
$DEFINE WS_TABSTOP        &H10000
$DEFINE WS_GROUP          &H20000
$DEFINE WS_MINIMIZEBOX    &H20000
$DEFINE WS_SIZEBOX        &H40000
$DEFINE WS_THICKFRAME     &H40000
$DEFINE WS_SYSMENU        &H80000
$DEFINE WS_HSCROLL       &H100000
$DEFINE WS_VSCROLL       &H200000
$DEFINE WS_DLGFRAME      &H400000
$DEFINE WS_BORDER        &H800000
$DEFINE WS_CAPTION       &HC00000
$DEFINE WS_MAXIMIZE     &H1000000
$DEFINE WS_CLIPCHILDREN &H2000000
$DEFINE WS_CLIPSIBLINGS &H4000000
$DEFINE WS_DISABLED     &H8000000
$DEFINE WS_VISIBLE     &H10000000
$DEFINE WS_ICONIC      &H20000000
$DEFINE WS_MINIMIZE    &H20000000
$DEFINE WS_CHILDWINDOW &H40000000
$DEFINE WS_CHILD       &H40000000
$DEFINE WS_POPUP       &H80000000
$DEFINE WS_POPUPWINDOW &H80880000
$DEFINE WS_OVERLAPPEDWINDOW &HCF0000
$DEFINE WS_TILEDWINDOW      &HCF0000

'Messages (see HBwinmsg.inc)

'Notification Codes
'These are ERROR_ codes

'''''BUTTON'''''
'ExStyle bits

'Style bits
$DEFINE BS_PUSHBUTTON      &H0
$DEFINE BS_TEXT            &H0
$DEFINE BS_DEFPUSHBUTTON   &H1
$DEFINE BS_CHECKBOX        &H2
$DEFINE BS_AUTOCHECKBOX    &H3
$DEFINE BS_RADIOBUTTON     &H4
$DEFINE BS_3STATE          &H5
$DEFINE BS_AUTO3STATE      &H6
$DEFINE BS_GROUPBOX        &H7
$DEFINE BS_USERBUTTON      &H8
$DEFINE BS_AUTORADIOBUTTON &H9
$DEFINE BS_OWNERDRAW       &HB
$DEFINE BS_LEFTTEXT       &H20
$DEFINE BS_RIGHTBUTTON    &H20
$DEFINE BS_BITMAP         &H80
$DEFINE BS_ICON           &H40
$DEFINE BS_LEFT          &H100
$DEFINE BS_RIGHT         &H200
$DEFINE BS_CENTER        &H300
$DEFINE BS_TOP           &H400
$DEFINE BS_BOTTOM        &H800
$DEFINE BS_VCENTER       &HC00
$DEFINE BS_PUSHLIKE     &H1000
$DEFINE BS_MULTILINE    &H2000
$DEFINE BS_NOTIFY       &H4000
$DEFINE BS_FLAT         &H8000

'Messages
$DEFINE BM_CLICK    &HF5
$DEFINE BM_GETCHECK &HF0
$DEFINE BM_GETIMAGE &HF6
$DEFINE BM_GETSTATE &HF2
$DEFINE BM_SETCHECK &HF1
$DEFINE BM_SETIMAGE &HF7
$DEFINE BM_SETSTATE &HF3
$DEFINE BM_SETSTYLE &HF4

'Notification Codes
$DEFINE BN_CLICKED 0
$DEFINE BN_PAINT 1
$DEFINE BN_HILITE 2
$DEFINE BN_PUSHED 2
$DEFINE BN_UNHILITE 3
$DEFINE BN_UNPUSHED 3
$DEFINE BN_DISABLE 4
$DEFINE BN_DBLCLK 5
$DEFINE BN_DOUBLECLICKED 5
$DEFINE BN_SETFOCUS 6
$DEFINE BN_KILLFOCUS 7

'''''CANVAS'''''(see LABEL)

'''''CHECKBOX'''''(see BUTTON)

'''''COMBOBOX'''''
'ExStyle bits

'Style bits
$DEFINE CBS_SIMPLE             &H1
$DEFINE CBS_DROPDOWN           &H2
$DEFINE CBS_DROPDOWNLIST       &H3
$DEFINE CBS_OWNERDRAWFIXED    &H10
$DEFINE CBS_OWNERDRAWVARIABLE &H20
$DEFINE CBS_AUTOHSCROLL       &H40
$DEFINE CBS_OEMCONVERT        &H80
$DEFINE CBS_SORT             &H100
$DEFINE CBS_HASSTRINGS       &H200
$DEFINE CBS_NOINTEGRALHEIGHT &H400
$DEFINE CBS_DISABLENOSCROLL  &H800
$DEFINE CBS_UPPERCASE 	    &H2000
$DEFINE CBS_LOWERCASE       &H4000

'Messages
$DEFINE CB_ADDSTRING &H143
$DEFINE CB_DELETESTRING &H144
$DEFINE CB_DIR &H145
$DEFINE CB_FINDSTRING &H14C
$DEFINE CB_FINDSTRINGEXACT &H158
$DEFINE CB_GETCOUNT &H146
$DEFINE CB_GETCURSEL &H147
$DEFINE CB_GETDROPPEDCONTROLRECT &H152
$DEFINE CB_GETDROPPEDSTATE &H157
$DEFINE CB_GETDROPPEDWIDTH &H15F
$DEFINE CB_GETEDITSEL &H140
$DEFINE CB_GETEXTENDEDUI &H156
$DEFINE CB_GETHORIZONTALEXTENT &H15D
$DEFINE CB_GETITEMDATA &H150
$DEFINE CB_GETITEMHEIGHT &H154
$DEFINE CB_GETLBTEXT &H148
$DEFINE CB_GETLBTEXTLEN &H149
$DEFINE CB_GETLOCALE &H15A
$DEFINE CB_GETTOPINDEX &H15B
$DEFINE CB_INITSTORAGE &H161
$DEFINE CB_INSERTSTRING &H14A
$DEFINE CB_LIMITTEXT &H141
$DEFINE CB_MSGMAX &H162
$DEFINE CB_RESETCONTENT &H14B
$DEFINE CB_SELECTSTRING &H14D
$DEFINE CB_SETCURSEL &H14E
$DEFINE CB_SETDROPPEDWIDTH &H160
$DEFINE CB_SETEDITSEL &H142
$DEFINE CB_SETEXTENDEDUI &H155
$DEFINE CB_SETHORIZONTALEXTENT &H15E
$DEFINE CB_SETITEMDATA &H151
$DEFINE CB_SETITEMHEIGHT &H153
$DEFINE CB_SETLOCALE &H159
$DEFINE CB_SETTOPINDEX &H15C
$DEFINE CB_SHOWDROPDOWN &H14F

'Error codes from SENDMESSAGE
$DEFINE CB_OKAY 0
$DEFINE CB_ERR -1
$DEFINE CB_ERRSPACE -2

'Notification Codes
$DEFINE CBN_ERRSPACE -1
$DEFINE CBN_SELCHANGE 1
$DEFINE CBN_DBLCLK 2
$DEFINE CBN_SETFOCUS 3
$DEFINE CBN_KILLFOCUS 4
$DEFINE CBN_EDITCHANGE 5
$DEFINE CBN_EDITUPDATE 6
$DEFINE CBN_DROPDOWN 7
$DEFINE CBN_CLOSEUP 8
$DEFINE CBN_SELENDOK 9
$DEFINE CBN_SELENDCANCEL 10

'''''DATETIME'''''
'ExStyle bits

'Style bits
$DEFINE DTS_SHORTDATEFORMAT 0
$DEFINE DTS_UPDOWN 1
$DEFINE DTS_SHOWNONE 2
$DEFINE DTS_LONGDATEFORMAT 4
$DEFINE DTS_TIMEFORMAT 9
$DEFINE DTS_SHORTDATECENTURYFORMAT &HC
$DEFINE DTS_APPCANPARSE &H10
$DEFINE DTS_RIGHTALIGN &H20

'Messages
$DEFINE DTM_GETMCCOLOR 4103
$DEFINE DTM_GETMCFONT 4106
$DEFINE DTM_GETMONTHCAL 4104
$DEFINE DTM_GETRANGE 4093
$DEFINE DTM_GETSYSTEMTIME 4097
$DEFINE DTM_SETFORMAT 4101
$DEFINE DTM_SETFORMATW 4146
$DEFINE DTM_SETMCCOLOR 4102
$DEFINE DTM_SETMCFONT 4105
$DEFINE DTM_SETRANGE 4100
$DEFINE DTM_SETSYSTEMTIME 4098

'Notification Codes
$DEFINE DTN_CLOSEUP -753
$DEFINE DTN_DATETIMECHANGE -759
$DEFINE DTN_DROPDOWN -754
$DEFINE DTN_FORMAT -756
$DEFINE DTN_FORMATW -743
$DEFINE DTN_FORMATQUERY -755
$DEFINE DTN_FORMATQUERYW -742
$DEFINE DTN_USERSTRING -758
$DEFINE DTN_USERSTRINGW -745
$DEFINE DTN_WMKEYDOWN -757
$DEFINE DTN_WMKEYDOWNW -744

'''''EDIT'''''
'ExStyle bits

'Style bits
$DEFINE ES_LEFT          &H0
$DEFINE ES_CENTER        &H1
$DEFINE ES_RIGHT         &H2
$DEFINE ES_MULTILINE     &H4
$DEFINE ES_UPPERCASE     &H8
$DEFINE ES_LOWERCASE    &H10
$DEFINE ES_PASSWORD     &H20
$DEFINE ES_AUTOVSCROLL  &H40
$DEFINE ES_AUTOHSCROLL  &H80
$DEFINE ES_NOHIDESEL   &H100
$DEFINE ES_OEMCONVERT  &H400
$DEFINE ES_READONLY    &H800
$DEFINE ES_WANTRETURN &H1000
$DEFINE ES_NUMBER     &H2000
$DEFINE ES_SELECTIONBAR &H1000000

'Messages
$DEFINE EM_CANUNDO &HC6
$DEFINE EM_CHARFROMPOS &HD7
$DEFINE EM_EMPTYUNDOBUFFER &HCD
$DEFINE EM_FMTLINES &HC8
$DEFINE EM_GETFIRSTVISIBLELINE &HCE
$DEFINE EM_GETHANDLE &HBD
$DEFINE EM_GETIMESTATUS &HD9
$DEFINE EM_GETLIMITTEXT &HD5
$DEFINE EM_GETLINE &HC4
$DEFINE EM_GETLINECOUNT &HBA
$DEFINE EM_GETMARGINS &HD4
$DEFINE EM_GETMODIFY &HB8
$DEFINE EM_GETPASSWORDCHAR &HD2
$DEFINE EM_GETRECT &HB2
$DEFINE EM_GETSEL &HB0
$DEFINE EM_GETTHUMB &HBE
$DEFINE EM_GETWORDBREAKPROC &HD1
$DEFINE EM_LIMITTEXT &HC5
$DEFINE EM_LINEFROMCHAR &HC9
$DEFINE EM_LINEINDEX &HBB
$DEFINE EM_LINELENGTH &HC1
$DEFINE EM_LINESCROLL &HB6
$DEFINE EM_POSFROMCHAR &HD6
$DEFINE EM_REPLACESEL &HC2
$DEFINE EM_SCROLL &HB5
$DEFINE EM_SCROLLCARET &HB7
$DEFINE EM_SETHANDLE &HBC
$DEFINE EM_SETIMESTATUS &HD8
$DEFINE EM_SETLIMITTEXT &HC5
$DEFINE EM_SETMARGINS &HD3
$DEFINE EM_SETMODIFY &HB9
$DEFINE EM_SETPASSWORDCHAR &HCC
$DEFINE EM_SETREADONLY &HCF
$DEFINE EM_SETRECT &HB3
$DEFINE EM_SETRECTNP &HB4
$DEFINE EM_SETSEL &HB1
$DEFINE EM_SETTABSTOPS &HCB
$DEFINE EM_SETWORDBREAKPROC &HD0
$DEFINE EM_UNDO &HC7

'Notification Mask Bits (all =&HFF0007)
$DEFINE ENM_NONE              &H0
$DEFINE ENM_CHANGE            &H1
$DEFINE ENM_UPDATE            &H2
$DEFINE ENM_SCROLL            &H4
$DEFINE ENM_KEYEVENTS     &H10000
$DEFINE ENM_MOUSEEVENTS   &H20000
$DEFINE ENM_REQUESTRESIZE &H40000
$DEFINE ENM_SELCHANGE     &H80000
$DEFINE ENM_DROPFILES    &H100000
$DEFINE ENM_PROTECTED    &H200000
$DEFINE ENM_CORRECTTEXT  &H400000
$DEFINE ENM_IMECHANGE    &H800000

'Notification Codes
$DEFINE EN_SETFOCUS  &H100
$DEFINE EN_KILLFOCUS &H200
$DEFINE EN_CHANGE    &H300
$DEFINE EN_UPDATE    &H400
$DEFINE EN_ERRSPACE  &H500
$DEFINE EN_MAXTEXT   &H501
$DEFINE EN_HSCROLL   &H601
$DEFINE EN_VSCROLL   &H602

'''''FILELISTBOX'''''(see LISTBOX)

'''''GAUGE'''''
'ExStyle bits

'Style bits
$DEFINE PBS_SMOOTH   &H1
$DEFINE PBS_VERTICAL &H4

'Messages
$DEFINE PBM_DELTAPOS 1027
$DEFINE PBM_GETPOS 1032
$DEFINE PBM_GETRANGE 1031
$DEFINE PBM_SETBARCOLOR 1033
$DEFINE PBM_SETBKCOLOR 513
$DEFINE PBM_SETPOS 1026
$DEFINE PBM_SETRANGE 1025
$DEFINE PBM_SETRANGE32 1030
$DEFINE PBM_SETSTEP 1028
$DEFINE PBM_STEPIT 1029

'Notification Codes

'''''GRID'''''(Report-style ListView)
'ExStyle bits
$DEFINE LVS_EX_GRIDLINES         &H1
$DEFINE LVS_EX_SUBITEMIMAGES     &H2
$DEFINE LVS_EX_CHECKBOXES        &H4
$DEFINE LVS_EX_TRACKSELECT       &H8
$DEFINE LVS_EX_HEADERDRAGDROP   &H10
$DEFINE LVS_EX_FULLROWSELECT    &H20
$DEFINE LVS_EX_ONECLICKACTIVATE &H40
$DEFINE LVS_EX_TWOCLICKACTIVATE &H80
$DEFINE LVS_EX_FLATSB          &H100
$DEFINE LVS_EX_REGIONAL        &H200
$DEFINE LVS_EX_INFOTIP         &H400
$DEFINE LVS_EX_UNDERLINEHOT    &H800
$DEFINE LVS_EX_UNDERLINECOLD  &H1000
$DEFINE LVS_EX_MULTIWORKAREAS &H2000
$DEFINE LVS_EX_LABELTIP       &H4000

'Style bits
$DEFINE LVS_ALIGNTOP          &H0
$DEFINE LVS_ICON              &H0
$DEFINE LVS_REPORT            &H1
$DEFINE LVS_SMALLICON         &H2
$DEFINE LVS_LIST              &H3
$DEFINE LVS_SINGLESEL         &H4
$DEFINE LVS_SHOWSELALWAYS     &H8
$DEFINE LVS_SORTASCENDING    &H10
$DEFINE LVS_SORTDESCENDING   &H20
$DEFINE LVS_SHAREIMAGELISTS  &H40
$DEFINE LVS_NOLABELWRAP      &H80
$DEFINE LVS_AUTOARRANGE     &H100
$DEFINE LVS_EDITLABELS      &H200
$DEFINE LVS_OWNERDRAWFIXED  &H400
$DEFINE LVS_ALIGNLEFT       &H800
$DEFINE LVS_OWNERDATA      &H1000
$DEFINE LVS_NOSCROLL       &H2000
$DEFINE LVS_NOCOLUMNHEADER &H4000
$DEFINE LVS_NOSORTHEADER   &H8000

'Style bit masks
$DEFINE LVS_TYPEMASK          &H3
$DEFINE LVS_ALIGNMASK       &HC00
$DEFINE LVS_TYPESTYLEMASK  &HFC00

'Messages
$DEFINE LVM_APPROXIMATEVIEWRECT 4160
$DEFINE LVM_ARRANGE 4118
$DEFINE LVM_CREATEDRAGIMAGE 4129
$DEFINE LVM_DELETEALLITEMS 4105
$DEFINE LVM_DELETECOLUMN 4124
$DEFINE LVM_DELETEITEM 4104
$DEFINE LVM_EDITLABEL 4119
$DEFINE LVM_EDITLABELW 4214
$DEFINE LVM_ENSUREVISIBLE 4115
$DEFINE LVM_GETBKCOLOR 4096
$DEFINE LVM_GETBKIMAGE 4165
$DEFINE LVM_GETBKIMAGEW 4235
$DEFINE LVM_GETCALLBACKMASK 4106
$DEFINE LVM_GETCOLUMN 4121
$DEFINE LVM_GETCOLUMNORDERARRAY 4155
$DEFINE LVM_GETCOLUMNW 4191
$DEFINE LVM_GETCOLUMNWIDTH 4125
$DEFINE LVM_GETCOUNTPERPAGE 4136
$DEFINE LVM_GETEDITCONTROL 4120
$DEFINE LVM_GETEXTENDEDLISTVIEWSTYLE 4151
$DEFINE LVM_GETHOTCURSOR 4159
$DEFINE LVM_GETHOTITEM 4157
$DEFINE LVM_GETHOVERTIME 4168
$DEFINE LVM_GETIMAGELIST 4098
$DEFINE LVM_GETISEARCHSTRING 4148
$DEFINE LVM_GETISEARCHSTRINGW 4213
$DEFINE LVM_GETITEM 4101
$DEFINE LVM_GETITEMCOUNT 4100
$DEFINE LVM_GETITEMPOSITION 4112
$DEFINE LVM_GETITEMRECT 4110
$DEFINE LVM_GETITEMSPACING 4147
$DEFINE LVM_GETITEMSTATE 4140
$DEFINE LVM_GETITEMTEXT 4141
$DEFINE LVM_GETITEMTEXTW 4211
$DEFINE LVM_GETITEMW 4171
$DEFINE LVM_GETNEXTITEM 4113
$DEFINE LVM_GETNUMBEROFWORKAREAS 4169
$DEFINE LVM_GETORIGIN 4137
$DEFINE LVM_GETSELECTEDCOUNT 4146
$DEFINE LVM_GETSELECTIONMARK 4162
$DEFINE LVM_GETSTRINGWIDTH 4113
$DEFINE LVM_GETSTRINGWIDTHW 4183
$DEFINE LVM_GETSUBITEMRECT 4152
$DEFINE LVM_GETTEXTBKCOLOR 4133
$DEFINE LVM_GETTEXTCOLOR 4131
$DEFINE LVM_GETTOOLTIPS 4174
$DEFINE LVM_GETTOPINDEX 4135
$DEFINE LVM_GETUNICODEFORMAT 518
$DEFINE LVM_GETVIEWRECT 4130
$DEFINE LVM_GETWORKAREAS 4166
$DEFINE LVM_HITTEST 4114
$DEFINE LVM_INSERTCOLUMN 4123
$DEFINE LVM_INSERTCOLUMNW 4193
$DEFINE LVM_INSERTITEM 4103
$DEFINE LVM_INSERTITEMW 4173
$DEFINE LVM_REDRAWITEMS 4117
$DEFINE LVM_SCROLL 4116
$DEFINE LVM_SETBKCOLOR 4097
$DEFINE LVM_SETBKIMAGE 4164
$DEFINE LVM_SETBKIMAGEW 4234
$DEFINE LVM_SETCALLBACKMASK 4107
$DEFINE LVM_SETCOLUMN 4122
$DEFINE LVM_SETCOLUMNORDERARRAY 4154
$DEFINE LVM_SETCOLUMNW 4192
$DEFINE LVM_SETCOLUMNWIDTH 4126
$DEFINE LVM_SETEXTENDEDLISTVIEWSTYLE 4150
$DEFINE LVM_SETHOTCURSOR 4158
$DEFINE LVM_SETHOTITEM 4156
$DEFINE LVM_SETHOVERTIME 4167
$DEFINE LVM_SETICONSPACING 4149
$DEFINE LVM_SETIMAGELIST 4099
$DEFINE LVM_SETITEM 4102
$DEFINE LVM_SETITEMCOUNT 4143
$DEFINE LVM_SETITEMPOSITION 4111
$DEFINE LVM_SETITEMPOSITION32 4145
$DEFINE LVM_SETITEMSTATE 4139
$DEFINE LVM_SETITEMTEXT 4142
$DEFINE LVM_SETITEMTEXTW 4212
$DEFINE LVM_SETITEMW 4172
$DEFINE LVM_SETSELECTIONMARK 4163
$DEFINE LVM_SETTEXTBKCOLOR 4134
$DEFINE LVM_SETTEXTCOLOR 4132
$DEFINE LVM_SETTOOLTIPS 4170
$DEFINE LVM_SETUNICODEFORMAT 517
$DEFINE LVM_SETWORKAREAS 4161
$DEFINE LVM_SORTITEMS 4144
$DEFINE LVM_SUBITEMHITTEST 4153
$DEFINE LVM_UPDATE 4138

'Notification Codes
$DEFINE LVN_BEGINDRAG -109
$DEFINE LVN_BEGINLABELEDIT -105
$DEFINE LVN_BEGINLABELEDITW -175
$DEFINE LVN_BEGINRDRAG -111
$DEFINE LVN_COLUMNCLICK -108
$DEFINE LVN_DELETEALLITEMS -104
$DEFINE LVN_DELETEITEM -103
$DEFINE LVN_ENDLABELEDIT -106
$DEFINE LVN_ENDLABELEDITW -176
$DEFINE LVN_ENDSCROLL -181
$DEFINE LVN_GETDISPINFO -150
$DEFINE LVN_GETDISPINFOW -177
$DEFINE LVN_GETINFOTIP -157
$DEFINE LVN_GETINFOTIPW -158
$DEFINE LVN_HOTTRACK -121
$DEFINE LVN_INSERTITEM -102
$DEFINE LVN_ITEMACTIVATE -114
$DEFINE LVN_ITEMCHANGED -101
$DEFINE LVN_ITEMCHANGING -100
$DEFINE LVN_KEYDOWN -155
$DEFINE LVN_MARQUEEBEGIN -156
$DEFINE LVN_ODCACHEHINT -113
$DEFINE LVN_ODFINDITEM -152
$DEFINE LVN_ODFINDITEMW -179
$DEFINE LVN_ODSTATECHANGED -115
$DEFINE LVN_SETDISPINFO -151
$DEFINE LVN_SETDISPINFOW -178

'''''GROUPBOX'''''(see BUTTON)

'''''HEADER'''''
'ExStyle bits

'Style bits
$DEFINE HDS_HORZ        &H0
$DEFINE HDS_BUTTONS     &H2
$DEFINE HDS_HIDDEN      &H8
$DEFINE HDS_HOTTRACK    &H4
$DEFINE HDS_DRAGDROP   &H40
$DEFINE HDS_FULLDRAG   &H80
$DEFINE HDS_FILTERBAR &H100

'Messages
$DEFINE HDM_CLEARFILTER 4632
$DEFINE HDM_CREATEDRAGIMAGE 4624
$DEFINE HDM_DELETEITEM 4610
$DEFINE HDM_EDITFILTER 4631
$DEFINE HDM_GETBITMAPMARGIN 4629
$DEFINE HDM_GETIMAGELIST 4617
$DEFINE HDM_GETITEM 4611
$DEFINE HDM_GETITEMCOUNT 4608
$DEFINE HDM_GETITEMRECT 4615
$DEFINE HDM_GETITEMW 4619
$DEFINE HDM_GETORDERARRAY 4625
$DEFINE HDM_GETUNICODEFORMAT 518
$DEFINE HDM_HITTEST 4614
$DEFINE HDM_INSERTITEM 4609
$DEFINE HDM_INSERTITEMW 4618
$DEFINE HDM_LAYOUT 4613
$DEFINE HDM_ORDERTOINDEX 4623
$DEFINE HDM_SETBITMAPMARGIN 4628
$DEFINE HDM_SETFILTERCHANGETIMEOUT 4630
$DEFINE HDM_SETHOTDIVIDER 4627
$DEFINE HDM_SETIMAGELIST 4616
$DEFINE HDM_SETITEM 4612
$DEFINE HDM_SETITEMW 4620
$DEFINE HDM_SETORDERARRAY 4626
$DEFINE HDM_SETUNICODEFORMAT 517

'Notification Codes
$DEFINE HDN_BEGINDRAG -310
$DEFINE HDN_BEGINTRACK -306
$DEFINE HDN_BEGINTRACKW -326
$DEFINE HDN_DIVIDERDBLCLICK -305
$DEFINE HDN_DIVIDERDBLCLICKW -325
$DEFINE HDN_ENDDRAG -311
$DEFINE HDN_ENDTRACK -307
$DEFINE HDN_ENDTRACKW -327
$DEFINE HDN_FILTERBTNCLICK -313
$DEFINE HDN_FILTERCHANGE -312
$DEFINE HDN_GETDISPINFO -309
$DEFINE HDN_GETDISPINFOW -329
$DEFINE HDN_ITEMCHANGED -301
$DEFINE HDN_ITEMCHANGEDW -321
$DEFINE HDN_ITEMCHANGING -300
$DEFINE HDN_ITEMCHANGINGW -320
$DEFINE HDN_ITEMCLICK -302
$DEFINE HDN_ITEMCLICKW -322
$DEFINE HDN_ITEMDBLCLICK -303
$DEFINE HDN_ITEMDBLCLICKW -323
$DEFINE HDN_TRACK -308
$DEFINE HDN_TRACKW -328

'''''IMAGE'''''(see LABEL)

'''''LABEL'''''
'ExStyle bits

'Style bits
$DEFINE SS_LEFT            &H0
$DEFINE SS_CENTER          &H1
$DEFINE SS_RIGHT           &H2
$DEFINE SS_ICON            &H3
$DEFINE SS_BLACKRECT       &H4
$DEFINE SS_GRAYRECT        &H5
$DEFINE SS_WHITERECT       &H6
$DEFINE SS_BLACKFRAME      &H7
$DEFINE SS_GRAYFRAME       &H8
$DEFINE SS_WHITEFRAME      &H9
$DEFINE SS_USERITEM        &HA
$DEFINE SS_SIMPLE          &HB
$DEFINE SS_LEFTNOWORDWRAP  &HC
$DEFINE SS_OWNERDRAW       &HD
$DEFINE SS_BITMAP          &HE
$DEFINE SS_ENHMETAFILE     &HF
$DEFINE SS_ETCHEDHORZ     &H10
$DEFINE SS_ETCHEDVERT     &H11
$DEFINE SS_ETCHEDFRAME    &H12
$DEFINE SS_TYPEMASK       &H1F
$DEFINE SS_NOPREFIX       &H80
$DEFINE SS_NOTIFY        &H100
$DEFINE SS_CENTERIMAGE   &H200
$DEFINE SS_RIGHTJUST     &H400
$DEFINE SS_REALSIZEIMAGE &H800
$DEFINE SS_SUNKEN       &H1000
$DEFINE SS_ENDELLIPSIS  &H4000
$DEFINE SS_PATHELLIPSIS &H8000
$DEFINE SS_WORDELLIPSIS &HC000
$DEFINE SS_ELLIPSISMASK &HC000

'Messages
$DEFINE STM_SETICON &H170
$DEFINE STM_GETICON &H171

'Notification Codes

'''''LISTBOX'''''
'ExStyle bits

'Style bits
$DEFINE LBS_NOTIFY              &H1
$DEFINE LBS_SORT                &H2
$DEFINE LBS_NOREDRAW            &H4
$DEFINE LBS_MULTIPLESEL         &H8
$DEFINE LBS_OWNERDRAWFIXED     &H10
$DEFINE LBS_OWNERDRAWVARIABLE  &H20
$DEFINE LBS_HASSTRINGS         &H40
$DEFINE LBS_USETABSTOPS        &H80
$DEFINE LBS_NOINTEGRALHEIGHT  &H100
$DEFINE LBS_MULTICOLUMN       &H200
$DEFINE LBS_WANTKEYBOARDINPUT &H400
$DEFINE LBS_EXTENDEDSEL       &H800
$DEFINE LBS_DISABLENOSCROLL  &H1000
$DEFINE LBS_NODATA           &H2000
$DEFINE LBS_STANDARD       &H200003

'Messages
$DEFINE LB_ADDFILE        &H196
$DEFINE LB_ADDSTRING      &H180
$DEFINE LB_DELETESTRING   &H182
$DEFINE LB_DIR            &H18D
$DEFINE LB_FINDSTRING     &H18F
$DEFINE LB_FINDSTRINGEXACT &H1A2
$DEFINE LB_GETANCHORINDEX &H19D
$DEFINE LB_GETCARETINDEX  &H19F
$DEFINE LB_GETCOUNT       &H18B
$DEFINE LB_GETCURSEL      &H188
$DEFINE LB_GETHORIZONTALEXTENT &H193
$DEFINE LB_GETITEMDATA    &H199
$DEFINE LB_GETITEMHEIGHT  &H1A1
$DEFINE LB_GETITEMRECT    &H198
$DEFINE LB_GETLOCALE      &H1A6
$DEFINE LB_GETSEL         &H187
$DEFINE LB_GETSELCOUNT    &H190
$DEFINE LB_GETSELITEMS    &H191
$DEFINE LB_GETTEXT        &H189
$DEFINE LB_GETTEXTLEN     &H18A
$DEFINE LB_GETTOPINDEX    &H18E
$DEFINE LB_INSERTSTRING   &H181
$DEFINE LB_MSGMAX         &H1A8
$DEFINE LB_RESETCONTENT   &H184
$DEFINE LB_SELECTSTRING   &H18C
$DEFINE LB_SELITEMRANGE   &H19B
$DEFINE LB_SELITEMRANGEEX &H183
$DEFINE LB_SETANCHORINDEX &H19C
$DEFINE LB_SETCARETINDEX  &H19E
$DEFINE LB_SETCOLUMNWIDTH &H195
$DEFINE LB_SETCOUNT       &H1A7
$DEFINE LB_SETCURSEL      &H186
$DEFINE LB_SETHORIZONTALEXTENT &H194
$DEFINE LB_SETITEMDATA    &H19A
$DEFINE LB_SETITEMHEIGHT  &H1A0
$DEFINE LB_SETLOCALE      &H1A5
$DEFINE LB_SETSEL         &H185
$DEFINE LB_SETTABSTOPS    &H192
$DEFINE LB_SETTOPINDEX    &H197

'Error codes from SENDMESSAGE
$DEFINE LB_OKAY 0
$DEFINE LB_ERR -1
$DEFINE LB_ERRSPACE -2

'Notification Codes
$DEFINE LBN_ERRSPACE -2
$DEFINE LBN_SELCHANGE 1
$DEFINE LBN_DBLCLK    2
$DEFINE LBN_SELCANCEL 3
$DEFINE LBN_SETFOCUS  4
$DEFINE LBN_KILLFOCUS 5

'''''PANEL'''''(see LABEL)

'''''RADIOBUTTON'''''(see BUTTON)

'''''RICHEDIT'''''(see EDIT)

'''''RICHEDIT2'''''
'ExStyle bits
$DEFINE ES_EX_NOCALLOLEINIT &H1000000

'Style bits
$DEFINE ES_LEFT          &H0
$DEFINE ES_CENTER        &H1
$DEFINE ES_RIGHT         &H2
$DEFINE ES_MULTILINE     &H4
$DEFINE ES_AUTOVSCROLL  &H40
$DEFINE ES_AUTOHSCROLL  &H80
$DEFINE ES_NOHIDESEL   &H100
$DEFINE ES_READONLY    &H800
$DEFINE ES_WANTRETURN &H1000
$DEFINE ES_NUMBER     &H2000
$DEFINE ES_DISABLENOSCROLL &H2000
$DEFINE ES_SUNKEN          &H4000
$DEFINE ES_SAVESEL         &H8000
$DEFINE ES_SELFIME        &H40000
$DEFINE ES_NOIME          &H80000
$DEFINE ES_VERTICAL      &H400000
$DEFINE ES_SELECTIONBAR &H1000000

'Messages
$DEFINE EM_AUTOURLDETECT 1115
$DEFINE EM_CHARFROMPOS 215
$DEFINE EM_CANPASTE 1074
$DEFINE EM_CANREDO 1109
$DEFINE EM_CANUNDO 198
$DEFINE EM_CONVPOSITION 1132
$DEFINE EM_DISPLAYBAND 1075
$DEFINE EM_EMPTYUNDOBUFFER 205
$DEFINE EM_EXGETSEL 1076
$DEFINE EM_EXLIMITTEXT 1077
$DEFINE EM_EXLINEFROMCHAR 1078
$DEFINE EM_EXSETSEL 1079
$DEFINE EM_FINDTEXT 1080
$DEFINE EM_FINDTEXTEX 1103
$DEFINE EM_FINDTEXTEXW 1148
$DEFINE EM_FINDTEXTW 1147
$DEFINE EM_FINDWORDBREAK 1100
$DEFINE EM_FORMATRANGE 1081
$DEFINE EM_GETAUTOURLDETECT 1116
$DEFINE EM_GETBIDIOPTIONS 1225
$DEFINE EM_GETCHARFORMAT 1082
$DEFINE EM_GETEDITSTYLE 1229
$DEFINE EM_GETEVENTMASK 1083
$DEFINE EM_GETFIRSTVISIBLELINE 206
$DEFINE EM_GETIMECOLOR 1129
$DEFINE EM_GETIMECOMPMODE 1146
$DEFINE EM_GETIMEMODEBIAS 1151
$DEFINE EM_GETIMEOPTIONS 1131
$DEFINE EM_GETLANGOPTIONS 1145
$DEFINE EM_GETLIMITTEXT 213
$DEFINE EM_GETLINECOUNT 186 
$DEFINE EM_GETLINE 196
$DEFINE EM_GETMODIFY 184
$DEFINE EM_GETOLEINTERFACE 1084
$DEFINE EM_GETOPTIONS 1102
$DEFINE EM_GETPARAFORMAT 1085
$DEFINE EM_GETPUNCTUATION 1125
$DEFINE EM_GETRECT 178
$DEFINE EM_GETREDONAME 1111
$DEFINE EM_GETSCROLLPOS 1245
$DEFINE EM_GETSEL 176
$DEFINE EM_GETSELTEXT 1086
$DEFINE EM_GETTEXTEX 1118
$DEFINE EM_GETTEXTLENGTHEX 1119
$DEFINE EM_GETTEXTMODE 1114
$DEFINE EM_GETTEXTRANGE 1099
$DEFINE EM_GETTHUMB 189
$DEFINE EM_GETTYPOGRAPHYOPTIONS 1227
$DEFINE EM_GETUNDONAME 1110
$DEFINE EM_GETWORDBREAKPROCEX 1104
$DEFINE EM_GETWORDBREAKPROC 209
$DEFINE EM_GETWORDWRAPMODE 1127
$DEFINE EM_GETZOOM 1248
$DEFINE EM_HIDESELECTION 1087
$DEFINE EM_LINEFROMCHAR 201
$DEFINE EM_LINEINDEX 187
$DEFINE EM_LINELENGTH 193
$DEFINE EM_OUTLINE 1244
$DEFINE EM_PASTESPECIAL 1088
$DEFINE EM_POSFROMCHAR 214
$DEFINE EM_RECONVERSION 1149
$DEFINE EM_REDO 1108
$DEFINE EM_REPLACESEL 194
$DEFINE EM_REQUESTRESIZE 1089
$DEFINE EM_SCROLLCARET 183
$DEFINE EM_SCROLL 181
$DEFINE EM_SELECTIONTYPE 1090
$DEFINE EM_SETBIDIOPTIONS 1224
$DEFINE EM_SETBKGNDCOLOR 1091
$DEFINE EM_SETCHARFORMAT 1092
$DEFINE EM_SETEDITSTYLE 1228
$DEFINE EM_SETEVENTMASK 1093
$DEFINE EM_SETFONTSIZE 1247
$DEFINE EM_SETIMECOLOR 1128
$DEFINE EM_SETIMEMODEBIAS 1150
$DEFINE EM_SETIMEOPTIONS 1130
$DEFINE EM_SETLANGOPTIONS 1144
$DEFINE EM_SETLIMITTEXT 197
$DEFINE EM_SETOLECALLBACK 1094
$DEFINE EM_SETOPTIONS 1101
$DEFINE EM_SETPALETTE 1117
$DEFINE EM_SETPARAFORMAT 1095
$DEFINE EM_SETPUNCTUATION 1124
$DEFINE EM_SETREADONLY 207
$DEFINE EM_SETRECT 197
$DEFINE EM_SETSCROLLPOS 1246
$DEFINE EM_SETSEL 195
$DEFINE EM_SETTARGETDEVICE 1096
$DEFINE EM_SETTEXTEX 1121
$DEFINE EM_SETTEXTMODE 1113
$DEFINE EM_SETTYPOGRAPHYOPTIONS 1226
$DEFINE EM_SETUNDOLIMIT 1106
$DEFINE EM_SETWORDBREAKPROCEX 1105
$DEFINE EM_SETWORDBREAKPROC 208
$DEFINE EM_SETWORDWRAPMODE 1126
$DEFINE EM_SETZOOM 1249
$DEFINE EM_SHOWSCROLLBAR 1120
$DEFINE EM_STOPGROUPTYPING 1112
$DEFINE EM_STREAMIN 1097
$DEFINE EM_STREAMOUT 1098
$DEFINE EM_UNDO 199

'Notification Codes
$DEFINE EN_SETFOCUS  &H100
$DEFINE EN_KILLFOCUS &H200
$DEFINE EN_CHANGE    &H300
$DEFINE EN_UPDATE    &H400
$DEFINE EN_ERRSPACE  &H500
$DEFINE EN_MAXTEXT   &H501
$DEFINE EN_HSCROLL   &H601
$DEFINE EN_VSCROLL   &H602
$DEFINE EN_MSGFILTER     &H700
$DEFINE EN_REQUESTRESIZE &H701
$DEFINE EN_SELCHANGE     &H702
$DEFINE EN_DROPFILES     &H703
$DEFINE EN_PROTECTED     &H704
$DEFINE EN_CORRECTTEXT   &H705
$DEFINE EN_STOPNOUNDO    &H706
$DEFINE EN_IMECHANGE     &H707
$DEFINE EN_SAVECLIPBOARD &H708
$DEFINE EN_OLEOPFAILED   &H709

'''''SCROLLBAR'''''
'ExStyle bits

'Style bits
$DEFINE SBS_HORZ        &H0
$DEFINE SBS_VERT        &H1
$DEFINE SBS_TOPALIGN    &H2
$DEFINE SBS_SIZEBOXTOPLEFTALIGN &H2
$DEFINE SBS_LEFTALIGN   &H2
$DEFINE SBS_BOTTOMALIGN &H4
$DEFINE SBS_RIGHTALIGN  &H4
$DEFINE SBS_SIZEBOXBOTTOMRIGHTALIGN &H4
$DEFINE SBS_SIZEBOX     &H8
$DEFINE SBS_SIZEGRIP   &H10

'Messages
$DEFINE SBM_ENABLE_ARROWS  &HE4
$DEFINE SBM_GETPOS         &HE1
$DEFINE SBM_GETRANGE       &HE3
$DEFINE SBM_GETSCROLLINFO  &HEA
$DEFINE SBM_SETPOS         &HE0
$DEFINE SBM_SETRANGE       &HE2
$DEFINE SBM_SETRANGEREDRAW &HE6
$DEFINE SBM_SETSCROLLINFO  &HE9

'Notification Codes
$DEFINE SB_LINEUP 0
$DEFINE SB_LINELEFT 0
$DEFINE SB_LINEDOWN 1
$DEFINE SB_LINERIGHT 1
$DEFINE SB_PAGEUP 2
$DEFINE SB_PAGELEFT 2
$DEFINE SB_PAGEDOWN 3
$DEFINE SB_PAGERIGHT 3
$DEFINE SB_THUMBPOSITION 4
$DEFINE SB_THUMBTRACK 5
$DEFINE SB_TOP 6
$DEFINE SB_LEFT 6
$DEFINE SB_BOTTOM 7
$DEFINE SB_RIGHT 7
$DEFINE SB_ENDSCROLL 8

'''''STATUSBAR'''''
'ExStyle bits

'Style bits
$DEFINE CCS_TOP 1
$DEFINE SBARS_SIZEGRIP &H100
$DEFINE SBARS_TOOLTIPS &H800

'Messages
$DEFINE SB_GETBORDERS 1031
$DEFINE SB_GETPARTS 1030
$DEFINE SB_GETRECT 1034
$DEFINE SB_GETTEXT 1026
$DEFINE SB_GETTEXTLENGTH 1027
$DEFINE SB_GETTEXTLENGTHW 1036
$DEFINE SB_GETTEXTW 1037
$DEFINE SB_SETMINHEIGHT 1032
$DEFINE SB_SETPARTS 1028
$DEFINE SB_SETTEXT 1025
$DEFINE SB_SETTEXTW 1035
$DEFINE SB_SIMPLE 1033

'Notification Codes

'''''TABCONTROL'''''
'ExStyle bits
$DEFINE TCS_EX_FLATSEPARATORS &H1
$DEFINE TCS_EX_REGISTERDROP   &H2

'Style bits
$DEFINE TCS_RIGHTJUSTIFY    &H0
$DEFINE TCS_SINGLELINE      &H0
$DEFINE TCS_TABS            &H0
$DEFINE TCS_SCROLLOPPOSITE  &H1
$DEFINE TCS_BOTTOM          &H2
$DEFINE TCS_MULTISELECT     &H4
$DEFINE TCS_FORCEICONLEFT  &H10
$DEFINE TCS_FORCELABELLEFT &H20
$DEFINE TCS_HOTTRACK       &H40
$DEFINE TCS_VERTICAL       &H80
$DEFINE TCS_BUTTONS       &H100
$DEFINE TCS_MULTILINE     &H200
$DEFINE TCS_FIXEDWIDTH    &H400
$DEFINE TCS_RAGGEDRIGHT   &H800
$DEFINE TCS_FOCUSONBUTTONDOWN &H1000
$DEFINE TCS_OWNERDRAWFIXED    &H2000
$DEFINE TCS_TOOLTIPS          &H4000
$DEFINE TCS_FOCUSNEVER        &H8000

'Messages
$DEFINE TCM_ADJUSTRECT 4904
$DEFINE TCM_DELETEALLITEMS 4873
$DEFINE TCM_DELETEITEM 4872
$DEFINE TCM_DESELECTALL 4914
$DEFINE TCM_FIRST &H1300
$DEFINE TCM_GETCURFOCUS 4911
$DEFINE TCM_GETCURSEL 4875
$DEFINE TCM_GETEXTENDEDSTYLE 4917
$DEFINE TCM_GETIMAGELIST 4866
$DEFINE TCM_GETITEM 4869
$DEFINE TCM_GETITEMCOUNT 4868
$DEFINE TCM_GETITEMRECT 4874
$DEFINE TCM_GETITEMW 4924
$DEFINE TCM_GETROWCOUNT 4908
$DEFINE TCM_GETTOOLTIPS 4909
$DEFINE TCM_GETUNICODEFORMAT 518
$DEFINE TCM_HIGHLIGHTITEM 4915
$DEFINE TCM_HITTEST 4877
$DEFINE TCM_INSERTITEM 4871
$DEFINE TCM_INSERTITEMW 4926
$DEFINE TCM_REMOVEIMAGE 4906
$DEFINE TCM_SETCURFOCUS 4912
$DEFINE TCM_SETCURSEL 4876
$DEFINE TCM_SETEXTENDEDSTYLE 4916
$DEFINE TCM_SETIMAGELIST 4867
$DEFINE TCM_SETITEM 4870
$DEFINE TCM_SETITEMEXTRA 4878
$DEFINE TCM_SETITEMSIZE 4905
$DEFINE TCM_SETITEMW 4925
$DEFINE TCM_SETMINTABWIDTH 4913
$DEFINE TCM_SETPADDING 4907
$DEFINE TCM_SETTOOLTIPS 4910
$DEFINE TCM_SETUNICODEFORMAT 517

'Notification Codes
$DEFINE TCN_KEYDOWN -550
$DEFINE TCN_SELCHANGE -551
$DEFINE TCN_SELCHANGING -552
$DEFINE TCN_GETOBJECT -553
$DEFINE TCN_FOCUSCHANGE -554

'''''TOOLBAR'''''
'ExStyle bits
$DEFINE TBSTYLE_EX_DRAWDDARROWS 1
$DEFINE TBSTYLE_EX_MIXEDBUTTONS 8
$DEFINE TBSTYLE_EX_HIDECLIPPEDBUTTONS &H10

'Style bits
$DEFINE TBSTYLE_BUTTON     &H0
$DEFINE TBSTYLE_SEP        &H1
$DEFINE TBSTYLE_CHECK      &H2
$DEFINE TBSTYLE_GROUP      &H4
$DEFINE TBSTYLE_CHECKGROUP &H6
$DEFINE TBSTYLE_DROPDOWN   &H8
$DEFINE TBSTYLE_AUTOSIZE  &H10
$DEFINE TBSTYLE_NOPREFIX  &H20
$DEFINE TBSTYLE_TOOLTIPS &H100
$DEFINE TBSTYLE_WRAPABLE &H200
$DEFINE TBSTYLE_ALTDRAG  &H400
$DEFINE TBSTYLE_FLAT     &H800
$DEFINE TBSTYLE_LIST    &H1000
$DEFINE TBSTYLE_CUSTOMERASE  &H2000
$DEFINE TBSTYLE_REGISTERDROP &H4000
$DEFINE TBSTYLE_TRANSPARENT  &H8000

'Messages
$DEFINE TB_ADDBITMAP 1043
$DEFINE TB_ADDBUTTONS 1044
$DEFINE TB_ADDBUTTONSW 1092
$DEFINE TB_ADDSTRING 1052
$DEFINE TB_ADDSTRINGW 1101
$DEFINE TB_AUTOSIZE 1057
$DEFINE TB_BUTTONCOUNT 1048
$DEFINE TB_BUTTONSTRUCTSIZE 1054
$DEFINE TB_CHANGEBITMAP 1067
$DEFINE TB_CHECKBUTTON 1026
$DEFINE TB_COMMANDTOINDEX 1049
$DEFINE TB_CUSTOMIZE 1051
$DEFINE TB_DELETEBUTTON 1046
$DEFINE TB_ENABLEBUTTON 1025
$DEFINE TB_GETANCHORHIGHLIGHT 1098
$DEFINE TB_GETBITMAP 1068
$DEFINE TB_GETBITMAPFLAGS 1065
$DEFINE TB_GETBUTTON 1047
$DEFINE TB_GETBUTTONINFO 1089
$DEFINE TB_GETBUTTONINFOW 1087
$DEFINE TB_GETBUTTONSIZE 1082
$DEFINE TB_GETBUTTONTEXT 1069
$DEFINE TB_GETBUTTONTEXTW 1099
$DEFINE TB_GETCOLORSCHEME 515
$DEFINE TB_GETDISABLEDIMAGELIST 1079
$DEFINE TB_GETEXTENDEDSTYLE 1109
$DEFINE TB_GETHOTIMAGELIST 1077
$DEFINE TB_GETHOTITEM 1095
$DEFINE TB_GETIMAGELIST 1073
$DEFINE TB_GETINSERTMARK 1103
$DEFINE TB_GETINSERTMARKCOLOR 1113
$DEFINE TB_GETITEMRECT 1053
$DEFINE TB_GETMAXSIZE 1107
$DEFINE TB_GETOBJECT 1086
$DEFINE TB_GETPADDING 1110
$DEFINE TB_GETRECT 1075
$DEFINE TB_GETROWS 1064
$DEFINE TB_GETSTATE 1042
$DEFINE TB_GETSTRING 1116
$DEFINE TB_GETSTRINGW 1115
$DEFINE TB_GETSTYLE 1081
$DEFINE TB_GETTEXTROWS 1085
$DEFINE TB_GETTOOLTIPS 1059
$DEFINE TB_GETUNICODEFORMAT 518
$DEFINE TB_HIDEBUTTON 1028
$DEFINE TB_HITTEST 1093
$DEFINE TB_INDETERMINATE 1029
$DEFINE TB_INSERTBUTTON 1045
$DEFINE TB_INSERTBUTTONW 1091
$DEFINE TB_INSERTMARKHITTEST 1105
$DEFINE TB_ISBUTTONCHECKED 1034
$DEFINE TB_ISBUTTONENABLED 1033
$DEFINE TB_ISBUTTONHIDDEN 1036
$DEFINE TB_ISBUTTONHIGHLIGHTED 1038
$DEFINE TB_ISBUTTONINDETERMINATE 1037
$DEFINE TB_ISBUTTONPRESSED 1035
$DEFINE TB_LOADIMAGES 1074
$DEFINE TB_MAPACCELERATOR 1102
$DEFINE TB_MAPACCELERATORW 1114
$DEFINE TB_MARKBUTTON 1030
$DEFINE TB_MOVEBUTTON 1106
$DEFINE TB_PRESSBUTTON 1027
$DEFINE TB_REPLACEBITMAP 1070
$DEFINE TB_SAVERESTORE 1050
$DEFINE TB_SAVERESTOREW 1100
$DEFINE TB_SETANCHORHIGHLIGHT 1097
$DEFINE TB_SETBITMAPSIZE 1056
$DEFINE TB_SETBUTTONINFO 1090
$DEFINE TB_SETBUTTONINFOW 1088
$DEFINE TB_SETBUTTONSIZE 1055
$DEFINE TB_SETBUTTONWIDTH 1083
$DEFINE TB_SETCMDID 1066
$DEFINE TB_SETCOLORSCHEME 514
$DEFINE TB_SETDISABLEDIMAGELIST 1078
$DEFINE TB_SETDRAWTEXTFLAGS 1094
$DEFINE TB_SETEXTENDEDSTYLE 1108
$DEFINE TB_SETHOTIMAGELIST 1076
$DEFINE TB_SETHOTITEM 1096
$DEFINE TB_SETIMAGELIST 1072
$DEFINE TB_SETINDENT 1071
$DEFINE TB_SETINSERTMARK 1104
$DEFINE TB_SETINSERTMARKCOLOR 1112
$DEFINE TB_SETMAXTEXTROWS 1084
$DEFINE TB_SETPADDING 1111
$DEFINE TB_SETPARENT 1061
$DEFINE TB_SETROWS 1063
$DEFINE TB_SETSTATE 1041
$DEFINE TB_SETSTYLE 1080
$DEFINE TB_SETTOOLTIPS 1060
$DEFINE TB_SETUNICODEFORMAT 517

'Notification Codes
$DEFINE TBN_BEGINADJUST -703
$DEFINE TBN_BEGINDRAG -701
$DEFINE TBN_CUSTHELP -709
$DEFINE TBN_DELETINGBUTTON -715
$DEFINE TBN_DRAGOUT -714
$DEFINE TBN_DROPDOWN -710
$DEFINE TBN_ENDADJUST -704
$DEFINE TBN_ENDDRAG -702
$DEFINE TBN_GETBUTTONINFO -700
$DEFINE TBN_GETBUTTONINFOW -720
$DEFINE TBN_GETDISPINFO -716
$DEFINE TBN_GETDISPINFOW -717
$DEFINE TBN_GETINFOTIP -718
$DEFINE TBN_GETINFOTIPW -719
$DEFINE TBN_GETOBJECT -712
$DEFINE TBN_HOTITEMCHANGE -713
$DEFINE TBN_INITCUSTOMIZE -723
$DEFINE TBN_QUERYDELETE -707
$DEFINE TBN_QUERYINSERT -706
$DEFINE TBN_RESET -705
$DEFINE TBN_RESTORE -721
$DEFINE TBN_SAVE -722
$DEFINE TBN_TOOLBARCHANGE -708

'''''TRACKBAR'''''
'ExStyle bits

'Style bits
$DEFINE TBS_BOTTOM    &H0
$DEFINE TBS_HORZ      &H0
$DEFINE TBS_RIGHT     &H0
$DEFINE TBS_AUTOTICKS &H1
$DEFINE TBS_VERT      &H2
$DEFINE TBS_LEFT      &H4
$DEFINE TBS_TOP       &H4
$DEFINE TBS_BOTH      &H8
$DEFINE TBS_NOTICKS        &H10
$DEFINE TBS_ENABLESELRANGE &H20
$DEFINE TBS_FIXEDLENGTH    &H40
$DEFINE TBS_NOTHUMB        &H80
$DEFINE TBS_TOOLTIPS      &H100
$DEFINE TBS_REVERSED      &H200

'Messages
$DEFINE TBM_CLEARSEL 1043
$DEFINE TBM_CLEARTICS 1033
$DEFINE TBM_GETBUDDY 1057
$DEFINE TBM_GETCHANNELRECT 1050
$DEFINE TBM_GETLINESIZE 1048
$DEFINE TBM_GETNUMTICS 1040
$DEFINE TBM_GETPAGESIZE 1046
$DEFINE TBM_GETPOS 1024
$DEFINE TBM_GETPTICS 1038
$DEFINE TBM_GETRANGEMAX 1026
$DEFINE TBM_GETRANGEMIN 1025
$DEFINE TBM_GETSELEND 1042
$DEFINE TBM_GETSELSTART 1041
$DEFINE TBM_GETTHUMBLENGTH 1052
$DEFINE TBM_GETTHUMBRECT 1049
$DEFINE TBM_GETTIC 1027
$DEFINE TBM_GETTICPOS 1039
$DEFINE TBM_GETTOOLTIPS 1054
$DEFINE TBM_GETUNICODEFORMAT 518
$DEFINE TBM_SETBUDDY 1056
$DEFINE TBM_SETLINESIZE 1047
$DEFINE TBM_SETPAGESIZE 1045
$DEFINE TBM_SETPOS 1029
$DEFINE TBM_SETRANGE 1030
$DEFINE TBM_SETRANGEMAX 1032
$DEFINE TBM_SETRANGEMIN 1031
$DEFINE TBM_SETSEL 1034
$DEFINE TBM_SETSELEND 1036
$DEFINE TBM_SETSELSTART 1035
$DEFINE TBM_SETTHUMBLENGTH 1051
$DEFINE TBM_SETTIC 1028
$DEFINE TBM_SETTICFREQ 1044
$DEFINE TBM_SETTIPSIDE 1055
$DEFINE TBM_SETTOOLTIPS 1053
$DEFINE TBM_SETUNICODEFORMAT 517

'Notification Codes
$DEFINE TB_LINEUP 0
$DEFINE TB_LINEDOWN 1
$DEFINE TB_PAGEUP 2
$DEFINE TB_PAGEDOWN 3
$DEFINE TB_THUMBPOSITION 4
$DEFINE TB_THUMBTRACK 5
$DEFINE TB_TOP 6
$DEFINE TB_BOTTOM 7
$DEFINE TB_ENDTRACK 8

'''''TREEVIEW'''''
'ExStyle bits

'Style bits
$DEFINE TVS_HASBUTTONS  1
$DEFINE TVS_HASLINES    2
$DEFINE TVS_LINESATROOT 4
$DEFINE TVS_EDITLABELS  8
$DEFINE TVS_DISABLEDRAGDROP &H10
$DEFINE TVS_SHOWSELALWAYS   &H20
$DEFINE TVS_RTLREADING      &H40
$DEFINE TVS_NOTOOLTIPS      &H80
$DEFINE TVS_CHECKBOXES     &H100
$DEFINE TVS_TRACKSELECT    &H200
$DEFINE TVS_SINGLEEXPAND   &H400
$DEFINE TVS_INFOTIP        &H800
$DEFINE TVS_FULLROWSELECT &H1000
$DEFINE TVS_NOSCROLL      &H2000
$DEFINE TVS_NONEVENHEIGHT &H4000
$DEFINE TVS_NOHSCROLL     &H8000

'Messages
$DEFINE TVM_CREATEDRAGIMAGE 4370
$DEFINE TVM_DELETEITEM 4353
$DEFINE TVM_EDITLABEL 4366
$DEFINE TVM_EDITLABELW 4417
$DEFINE TVM_ENDEDITLABELNOW 4374
$DEFINE TVM_ENSUREVISIBLE 4372
$DEFINE TVM_EXPAND 4354
$DEFINE TVM_GETBKCOLOR 4383
$DEFINE TVM_GETCOUNT 4357
$DEFINE TVM_GETEDITCONTROL 4367
$DEFINE TVM_GETIMAGELIST 4360
$DEFINE TVM_GETINDENT 4358
$DEFINE TVM_GETINSERTMARKCOLOR 4390
$DEFINE TVM_GETISEARCHSTRING 4375
$DEFINE TVM_GETISEARCHSTRINGW 4375
$DEFINE TVM_GETITEM 4364
$DEFINE TVM_GETITEMHEIGHT 4380
$DEFINE TVM_GETITEMRECT 4356
$DEFINE TVM_GETITEMSTATE 4391
$DEFINE TVM_GETITEMW 4414
$DEFINE TVM_GETLINECOLOR 4393
$DEFINE TVM_GETNEXTITEM 4362
$DEFINE TVM_GETSCROLLTIME 4386
$DEFINE TVM_GETTEXTCOLOR 4384
$DEFINE TVM_GETTOOLTIPS 4377
$DEFINE TVM_GETUNICODEFORMAT 518
$DEFINE TVM_GETVISIBLECOUNT 4368
$DEFINE TVM_HITTEST 4369
$DEFINE TVM_INSERTITEM 4352
$DEFINE TVM_INSERTITEMW 4402
$DEFINE TVM_SELECTITEM 4363
$DEFINE TVM_SETBKCOLOR 4381
$DEFINE TVM_SETIMAGELIST 4361
$DEFINE TVM_SETINDENT 4359
$DEFINE TVM_SETINSERTMARK 4378
$DEFINE TVM_SETINSERTMARKCOLOR 4389
$DEFINE TVM_SETITEM 4365
$DEFINE TVM_SETITEMHEIGHT 4379
$DEFINE TVM_SETITEMW 4415
$DEFINE TVM_SETLINECOLOR 4392
$DEFINE TVM_SETSCROLLTIME 4385
$DEFINE TVM_SETTEXTCOLOR 4382
$DEFINE TVM_SETTOOLTIPS 4376
$DEFINE TVM_SETUNICODEFORMAT 517
$DEFINE TVM_SORTCHILDREN 4371
$DEFINE TVM_SORTCHILDRENCB 4373

'Notification Codes
$DEFINE TVN_BEGINDRAG -407
$DEFINE TVN_BEGINDRAGW -456
$DEFINE TVN_BEGINLABELEDIT -410
$DEFINE TVN_BEGINLABELEDITW -459
$DEFINE TVN_BEGINRDRAG -408
$DEFINE TVN_BEGINRDRAGW -457
$DEFINE TVN_DELETEITEM -409
$DEFINE TVN_DELETEITEMW -458
$DEFINE TVN_ENDLABELEDIT -411
$DEFINE TVN_ENDLABELEDITW -460
$DEFINE TVN_GETDISPINFO -403
$DEFINE TVN_GETDISPINFOW -452
$DEFINE TVN_GETINFOTIP -413
$DEFINE TVN_GETINFOTIPW -414
$DEFINE TVN_ITEMEXPANDED -406
$DEFINE TVN_ITEMEXPANDEDW -455
$DEFINE TVN_ITEMEXPANDING -405
$DEFINE TVN_ITEMEXPANDINGW -454
$DEFINE TVN_KEYDOWN -412
$DEFINE TVN_SELCHANGED -402
$DEFINE TVN_SELCHANGEDW -451
$DEFINE TVN_SELCHANGING -401
$DEFINE TVN_SELCHANGINGW -450
$DEFINE TVN_SETDISPINFO -404
$DEFINE TVN_SETDISPINFOW -453
$DEFINE TVN_SINGLEEXPAND -415

'''''UPDOWN'''''
'ExStyle bits

'Style bits
$DEFINE UDS_WRAP         &H1
$DEFINE UDS_SETBUDDYINT  &H2
$DEFINE UDS_ALIGNRIGHT   &H4
$DEFINE UDS_ALIGNLEFT    &H8
$DEFINE UDS_AUTOBUDDY   &H10
$DEFINE UDS_ARROWKEYS   &H20
$DEFINE UDS_HORZ        &H40
$DEFINE UDS_NOTHOUSANDS &H80
$DEFINE UDS_HOTTRACK   &H100

'Messages
$DEFINE UDM_GETACCEL 1132
$DEFINE UDM_GETBASE 1134
$DEFINE UDM_GETBUDDY 1130
$DEFINE UDM_GETPOS 1128
$DEFINE UDM_GETPOS32 1138
$DEFINE UDM_GETRANGE 1126
$DEFINE UDM_GETRANGE32 1136
$DEFINE UDM_GETUNICODEFORMAT 518
$DEFINE UDM_SETACCEL 1131
$DEFINE UDM_SETBASE 1133
$DEFINE UDM_SETBUDDY 1129
$DEFINE UDM_SETPOS 1127
$DEFINE UDM_SETPOS32 1137
$DEFINE UDM_SETRANGE 1125
$DEFINE UDM_SETRANGE32 1135
$DEFINE UDM_SETUNICODEFORMAT 517

'Notification Codes
$DEFINE UDN_DELTAPOS -722
