'HBimage.inc summarizes some image-related constants.
'Updated: Aug 13, 2004
'Copyright 2004 James J Keene
'Information provided by Microsoft Corporation.

'This file uses $DEFINE instead of CONST.  CONST defines a memory location
'with a value.  $DEFINE uses "text replacement" and leads to slightly
'shorter programs since source code references to constants are replaced
'with the numerical value.

'This file may be best used as a reference or selections can be cut and
'pasted into your source code.
'$INCLUDE of the entire file may be done, but compile time will increase.


'For BUTTON or IMAGE objects, the .Icon property may be
'= to one of these internal Windows icon images:

$DEFINE IDI_ERROR       IDI_HAND
$DEFINE IDI_INFORMATION IDI_ASTERISK
$DEFINE IDI_WARNING     IDI_EXCLAMATION
$DEFINE IDI_APPLICATION 32512
$DEFINE IDI_HAND        32513
$DEFINE IDI_QUESTION    32514
$DEFINE IDI_EXCLAMATION 32515
$DEFINE IDI_ASTERISK    32516
$DEFINE IDI_WINLOGO     32517


'For BUTTON or IMAGE objects, the .Bmp property may be
'= to one of these internal Windows bitmap images:

$DEFINE OBM_OLD_CLOSE   32767
$DEFINE OBM_SIZE        32766
$DEFINE OBM_OLD_UPARROW 32765
$DEFINE OBM_OLD_DNARROW 32764
$DEFINE OBM_OLD_RGARROW 32763
$DEFINE OBM_OLD_LFARROW 32762
$DEFINE OBM_BTSIZE      32761
$DEFINE OBM_CHECK       32760
$DEFINE OBM_CHECKBOXES  32759
$DEFINE OBM_BTNCORNERS  32758
$DEFINE OBM_OLD_REDUCE  32757
$DEFINE OBM_OLD_ZOOM    32756
$DEFINE OBM_OLD_RESTORE 32755
$DEFINE OBM_CLOSE    32754
$DEFINE OBM_REDUCED  32746
$DEFINE OBM_REDUCE   32749
$DEFINE OBM_ZOOMD    32745
$DEFINE OBM_ZOOM     32748
$DEFINE OBM_RESTORED 32744
$DEFINE OBM_RESTORE  32747
$DEFINE OBM_UPARROWD 32743
$DEFINE OBM_DNARROWD 32742
$DEFINE OBM_RGARROWD 32741
$DEFINE OBM_LFARROWD 32740
$DEFINE OBM_MNARROW  32739
$DEFINE OBM_COMBO    32738
$DEFINE OBM_UPARROWI 32737
$DEFINE OBM_DNARROWI 32736
$DEFINE OBM_RGARROWI 32735
$DEFINE OBM_LFARROWI 32734
$DEFINE OBM_UPARROW  32753
$DEFINE OBM_DNARROW  32752
$DEFINE OBM_RGARROW  32751
$DEFINE OBM_LFARROW  32750


'The .Cursor property may be = to one of these
'internal Windows cursor images:

$DEFINE IDC_ARROW    32512
$DEFINE IDC_IBEAM    32513
$DEFINE IDC_WAIT     32514
$DEFINE IDC_CROSS    32515
$DEFINE IDC_UPARROW  32516
$DEFINE IDC_SIZE     32640
$DEFINE IDC_ICON     32641
$DEFINE IDC_SIZENWSE 32642
$DEFINE IDC_SIZENESW 32643
$DEFINE IDC_SIZEWE   32644
$DEFINE IDC_SIZENS   32645
$DEFINE IDC_SIZEALL  32646
$DEFINE IDC_NO       32648
$DEFINE IDC_HAND     32649
$DEFINE IDC_APPSTARTING 32650
$DEFINE IDC_HELP     32651

'On some systems, higher values denote other internal
'cursor images!  Check it out.
