'HBwinmsg.inc provides a handy summary of GUI constants.
'Updated: March 20, 2004
'Copyright 2004 James J Keene
'Information provided by Microsoft Corporation.

'This file uses $DEFINE instead of CONST.  CONST defines a memory location
'with a value.  $DEFINE uses "text replacement" and leads to slightly
'shorter programs since source code references to constants are replaced
'with the numerical value.

'This file may be best used as a reference or selections can be cut and
'pasted into your source code.
'$INCLUDE of the entire file may be done, but compile time will increase.

'''''FORM
'Messages
$DEFINE WM_NULL &H0
$DEFINE WM_CREATE &H1
$DEFINE WM_DESTROY &H2
$DEFINE WM_MOVE &H3
$DEFINE WM_SIZE &H5
$DEFINE WM_ACTIVATE &H6
$DEFINE WM_SETFOCUS &H7
$DEFINE WM_KILLFOCUS &H8
$DEFINE WM_ENABLE &HA
$DEFINE WM_SETREDRAW &HB
$DEFINE WM_SETTEXT &HC
$DEFINE WM_GETTEXT &HD
$DEFINE WM_GETTEXTLENGTH &HE
$DEFINE WM_PAINT &HF
$DEFINE WM_CLOSE &H10
$DEFINE WM_QUERYENDSESSION &H11
$DEFINE WM_QUIT &H12
$DEFINE WM_QUERYOPEN &H13
$DEFINE WM_ERASEBKGND &H14
$DEFINE WM_SYSCOLORCHANGE &H15
$DEFINE WM_ENDSESSION &H16
$DEFINE WM_SHOWWINDOW &H18
$DEFINE WM_WININICHANGE &H1A
$DEFINE WM_SETTINGCHANGE &H1A
$DEFINE WM_DEVMODECHANGE &H1B
$DEFINE WM_ACTIVATEAPP &H1C
$DEFINE WM_FONTCHANGE &H1D
$DEFINE WM_TIMECHANGE &H1E
$DEFINE WM_CANCELMODE &H1F
$DEFINE WM_SETCURSOR &H20
$DEFINE WM_MOUSEACTIVATE &H21
$DEFINE WM_CHILDACTIVATE &H22
$DEFINE WM_QUEUESYNC &H23
$DEFINE WM_GETMINMAXINFO &H24
$DEFINE WM_PAINTICON &H26
$DEFINE WM_ICONERASEBKGND &H27
$DEFINE WM_NEXTDLGCTL &H28
$DEFINE WM_SPOOLERSTATUS &H2A
$DEFINE WM_DRAWITEM &H2B
$DEFINE WM_MEASUREITEM &H2C
$DEFINE WM_DELETEITEM &H2D
$DEFINE WM_VKEYTOITEM &H2E
$DEFINE WM_CHARTOITEM &H2F
$DEFINE WM_SETFONT &H30
$DEFINE WM_GETFONT &H31
$DEFINE WM_SETHOTKEY &H32
$DEFINE WM_GETHOTKEY &H33
$DEFINE WM_QUERYDRAGICON &H37
$DEFINE WM_COMPAREITEM &H39
$DEFINE WM_GETOBJECT &H3D
$DEFINE WM_COMPACTING &H41
$DEFINE WM_OTHERWINDOWCREATED &H42
$DEFINE WM_OTHERWINDOWDESTROYED &H43
$DEFINE WM_COMMNOTIFY &H44
$DEFINE WM_WINDOWPOSCHANGING &H46
$DEFINE WM_WINDOWPOSCHANGED &H47
$DEFINE WM_POWER &H48
$DEFINE WM_COPYDATA &H4A
$DEFINE WM_CANCELJOURNAL &H4B
$DEFINE WM_NOTIFY &H4E
$DEFINE WM_INPUTLANGCHANGEREQUEST &H50
$DEFINE WM_INPUTLANGCHANGE &H51
$DEFINE WM_TCARD &H52
$DEFINE WM_HELP &H53
$DEFINE WM_USERCHANGED &H54
$DEFINE WM_NOTIFYFORMAT &H55
$DEFINE WM_CONTEXTMENU &H7B
$DEFINE WM_STYLECHANGING &H7C
$DEFINE WM_STYLECHANGED &H7D
$DEFINE WM_DISPLAYCHANGE &H7E
$DEFINE WM_GETICON &H7F
$DEFINE WM_SETICON &H80
$DEFINE WM_NCCREATE &H81
$DEFINE WM_NCDESTROY &H82
$DEFINE WM_NCCALCSIZE &H83
$DEFINE WM_NCHITTEST &H84
$DEFINE WM_NCPAINT &H85
$DEFINE WM_NCACTIVATE &H86
$DEFINE WM_GETDLGCODE &H87
$DEFINE WM_SYNCPAINT &H88
$DEFINE WM_NCMOUSEMOVE &HA0
$DEFINE WM_NCLBUTTONDOWN &HA1
$DEFINE WM_NCLBUTTONUP &HA2
$DEFINE WM_NCLBUTTONDBLCLK &HA3
$DEFINE WM_NCRBUTTONDOWN &HA4
$DEFINE WM_NCRBUTTONUP &HA5
$DEFINE WM_NCRBUTTONDBLCLK &HA6
$DEFINE WM_NCMBUTTONDOWN &HA7
$DEFINE WM_NCMBUTTONUP &HA8
$DEFINE WM_NCMBUTTONDBLCLK &HA9
$DEFINE WM_KEYFIRST &H100
$DEFINE WM_KEYDOWN &H100
$DEFINE WM_KEYUP &H101
$DEFINE WM_CHAR &H102
$DEFINE WM_DEADCHAR &H103
$DEFINE WM_SYSKEYDOWN &H104
$DEFINE WM_SYSKEYUP &H105
$DEFINE WM_SYSCHAR &H106
$DEFINE WM_SYSDEADCHAR &H107
$DEFINE WM_KEYLAST &H108
$DEFINE WM_INITDIALOG &H110
$DEFINE WM_COMMAND &H111
$DEFINE WM_SYSCOMMAND &H112
$DEFINE WM_TIMER &H113
$DEFINE WM_HSCROLL &H114
$DEFINE WM_VSCROLL &H115
$DEFINE WM_INITMENU &H116
$DEFINE WM_INITMENUPOPUP &H117
$DEFINE WM_MENUSELECT &H11F
$DEFINE WM_MENUCHAR &H120
$DEFINE WM_ENTERIDLE &H121
$DEFINE WM_CTLCOLORMSGBOX &H132
$DEFINE WM_CTLCOLOREDIT &H133
$DEFINE WM_CTLCOLORLISTBOX &H134
$DEFINE WM_CTLCOLORBTN &H135
$DEFINE WM_CTLCOLORDLG &H136
$DEFINE WM_CTLCOLORSCROLLBAR &H137
$DEFINE WM_CTLCOLORSTATIC &H138
$DEFINE WM_MOUSEFIRST &H200
$DEFINE WM_MOUSEMOVE &H200
$DEFINE WM_LBUTTONDOWN &H201
$DEFINE WM_LBUTTONUP &H202
$DEFINE WM_LBUTTONDBLCLK &H203
$DEFINE WM_RBUTTONDOWN &H204
$DEFINE WM_RBUTTONUP &H205
$DEFINE WM_RBUTTONDBLCLK &H206
$DEFINE WM_MBUTTONDOWN &H207
$DEFINE WM_MBUTTONUP &H208
$DEFINE WM_MBUTTONDBLCLK &H209
$DEFINE WM_MOUSELAST &H209
$DEFINE WM_PARENTNOTIFY &H210
$DEFINE WM_ENTERMENULOOP &H211
$DEFINE WM_EXITMENULOOP &H212
$DEFINE WM_MDICREATE &H220
$DEFINE WM_MDIDESTROY &H221
$DEFINE WM_MDIACTIVATE &H222
$DEFINE WM_MDIRESTORE &H223
$DEFINE WM_MDINEXT &H224
$DEFINE WM_MDIMAXIMIZE &H225
$DEFINE WM_MDITILE &H226
$DEFINE WM_MDICASCADE &H227
$DEFINE WM_MDIICONARRANGE &H228
$DEFINE WM_MDIGETACTIVE &H229
$DEFINE WM_MDISETMENU &H230
$DEFINE WM_DROPFILES &H233
$DEFINE WM_MDIREFRESHMENU &H234
$DEFINE WM_CUT &H300
$DEFINE WM_COPY &H301
$DEFINE WM_PASTE &H302
$DEFINE WM_CLEAR &H303
$DEFINE WM_UNDO &H304
$DEFINE WM_RENDERFORMAT &H305
$DEFINE WM_RENDERALLFORMATS &H306
$DEFINE WM_DESTROYCLIPBOARD &H307
$DEFINE WM_DRAWCLIPBOARD &H308
$DEFINE WM_PAINTCLIPBOARD &H309
$DEFINE WM_VSCROLLCLIPBOARD &H30A
$DEFINE WM_SIZECLIPBOARD &H30B
$DEFINE WM_ASKCBFORMATNAME &H30C
$DEFINE WM_CHANGECBCHAIN &H30D
$DEFINE WM_HSCROLLCLIPBOARD &H30E
$DEFINE WM_QUERYNEWPALETTE &H30F
$DEFINE WM_PALETTEISCHANGING &H310
$DEFINE WM_PALETTECHANGED &H311
$DEFINE WM_HOTKEY &H312
$DEFINE WM_PRINT &H317
$DEFINE WM_PRINTCLIENT &H318
$DEFINE WM_PENWINFIRST &H380
$DEFINE WM_PENWINLAST &H38F
$DEFINE WM_USER &H400
