'SBpanels.inc Copyright 2004-2006 James J. Keene
'Updated: March 7, 2006

'Code assumes statusbar symbol is SB
'Insert this include file after SB is dimensioned.
'For multi-form applications, include multiple copies
'of this include file with "SB" edited to SB1, SB2, etc.

$DEFINE NumberPanels 6  'edit to your number of panels
DefInt nPanels, iPanel, sumPanel
nPanels = NumberPanels: DEC(nPanels)  'get 0-Based number of panels
DIM SB_Panels(nPanels) As LONG
DIM SB_Right(nPanels) As LONG

'Panel is 0-Based index for statusbar panel

Declare SUB SB_Panel(Panel As LONG, PanelWidth As LONG)
Declare SUB SB_SetParts
Declare SUB SB_Text(Panel As LONG, lpPanelText As LONG)

'First, set your panel widths

SUB SB_Panel(Panel As LONG, PanelWidth As LONG)
SB_Panels(Panel) = PanelWidth
END SUB

'Second, calculate offsets and send message
'If you change a width, call SB_SetParts again

SUB SB_SetParts
sumPanel = SB_Panels(zero): iPanel = zero
NextSBPanel:
SB_Right(iPanel) = sumPanel: inc(iPanel)
sumPanel = sumPanel + SB_Panels(iPanel)
IF iPanel < nPanels THEN Goto NextSBPanel
SB_Right(nPanels) = -1
iPanel = SENDMESSAGE(SB, 1028, NumberPanels, @SB_Right)
END SUB

'Third, at any time, set panel text

SUB SB_Text(Panel As LONG, lpPanelText As LONG)
iPanel = SENDMESSAGE(SB, 1025, Panel, lpPanelText)
END SUB

$UNDEF NumberPanels
