'Updated: Mar 31, 2007
'written by Joe "TronDoc"

'usage:  MyDir$ = BrowseForFolder
'may return null string if user selects nothing

Declare FUNCTION BrowseForFolder As STRING

DECLARE FUNCTION SHGetPathFromIDList LIB "shell32" _
  (pidl As LONG, lpPath As LONG) As LONG 
DECLARE FUNCTION SHBrowseForFolder LIB "shell32" _
  (lpbi As LONG) As LONG
DECLARE SUB CoTaskMemFree LIB "ole32" _
  (pidl As LONG)   

'begin BROWSEINFO structure
defLNG hOwner,pidlRoot,lpDisplayName,lpTitle
defLNG ulFlags,lpfn,lParam2,iImage
'end BROWSEINFO structure

DEFSTR projectPATH$
DEFSTR pathBuffer$ = STRING$(260,CHR$(0))
DEFSTR BFFtitle$ = "Select Directory"
DEFLNG lpIDList,retPath

FUNCTION BrowseForFolder
result=null
'set BROWSEINFO
hOwner = zero: pidlRoot = zero
lpDisplayName = @pathBuffer$
lpTitle = @BFFtitle$
ulFlags = one: lpfn = zero
lParam2 = zero: iImage = zero
 
lpIDList = SHBrowseForFolder(@hOwner)
IF lpIDList THEN
  retPath = SHGetPathFromIDList(lpIDList,@pathBuffer$)
  IF retPath THEN CoTaskMemFree(lpIDList)
  result=left$(pathBuffer$,len(pathBuffer$))
END IF 
END FUNCTION
