'SaveBMP.inc Copyright 2005 James J Keene
'Updated: Aug 11, 2005

'Usage: SaveBMP(pathname string, pointer to BITMAP Object)

'Example:
'dim MyBMP as BITMAP
'SaveBMP "MyBMP.bmp", @MyBMP

Declare SUB SaveBMP (fBMP$ As STRING, lpBMP As LONG)

SUB SaveBMP
DIM f as FILE, i as INTEGER, j as INTEGER, bmp$ as STRING
f.OPEN(fBMP$,65535)
'write BITMAPFILEHEADER
f.writestr("BM",2)
i=BYREF(lpBMP+20)+54: f.write(i)  'file size
i=zero: f.write(i)   'reserved
i=54: f.write(i)  'OffBits
'write BITMAPINFOHEADER
bmp$=space$(40)
BYREF(lpBMP+16)=zero      '.Compression = 0
memcpy @bmp$,lpBMP,40  'get it
f.writestr(bmp$,40)
i=BYREF(lpBMP+20)  'get SizeImage
IF NOT i THEN bmp$="zero SizeImage": Goto saveBMP_Error
j=BYREF(lpBMP+48)  'get pointer
if NOT j THEN bmp$="pointer not found": Goto saveBMP_Error
bmp$=STRING$(i,chr$(0))
memcpy @bmp$,j,i  'get image data
f.write(bmp$)     'write image data
f.close: bmp$.clear: Exit SUB

saveBMP_Error:
ShowMessage "SaveBMP error"+crlf+bmp$
f.close: kill fBMP$
END SUB
