'TabStop.inc Copyright 2004-2006 James J Keene
'Updated: Feb 7, 2007

'1. we register the object handle and its tabstop position
'   with the TabReg SUB
'2. for the application main FORM, we define an .OnMessage event
'   containing:
'   IF uMsg=&H102 AND wParam=9 THEN call TabStop

Declare SUB TabReg (hObj as LONG, TabPos as LONG)
Declare SUB TabStop

$DEFINE TabHandle 0
$DEFINE TabOrder 1
$DEFINE MaxTabReg 49
$DEFINE VK_SHIFT 16

DIM TabDat(1,MaxTabReg) as LONG  'allows up to 50 objects
DEFINT nTabReg

'''''
SUB TabReg (hObj as LONG, TabPos as LONG)
DEFINT i
FOR i=zero to nTabReg-1
  IF TabDat(TabHandle,i) = hObj THEN
    TabDat(TabOrder,i) = TabPos: Exit Sub
  END IF
NEXT i
TabDat(TabHandle,nTabReg) = hObj
TabDat(TabOrder,nTabReg) = TabPos
IF nTabReg < MaxTabReg THEN INC(nTabReg)
END SUB

'''''
SUB TabStop
DEFINT h0,h1,h2,i,j,k,n,rec,hObj
DEFSHORT up
IF rec THEN Exit SUB ELSE INC(rec)  'prevent recursion
IF NOT hObj THEN hObj=TabDat(TabHandle,zero) 'auto-initialize
up=CONSOLE.KeyState(VK_SHIFT)

'get current TabOrder
IF up>=zero THEN n=MaxTabReg+2 ELSE n=zero
h1=zero
FOR i=zero to nTabReg-1
h0=TabDat(TabHandle,i)
k=TabDat(TabOrder,i)
IF h0 = hObj THEN j=k
IF up>=zero THEN
  IF k<n THEN n=k: h1=h0
ELSE
  IF k>n THEN n=k: h1=h0
END IF
NEXT i
IF not j THEN Goto TabStopDone

' j = current tab order (position)
'h1 = handle of lowest or highest tab order object
GotTabOrder:
IF up>=zero THEN n=MaxTabReg+2 ELSE n=zero
h2=zero
FOR i=zero to nTabReg-1
h0=TabDat(TabHandle,i)
IF h0<>hObj THEN
  k=TabDat(TabOrder,i)
  IF up>=zero THEN
    IF k>j AND k<n THEN n=k: h2=h0
  ELSE
    IF k<j AND k>n THEN n=k: h2=h0
  END IF
END IF
NEXT i

'Did we find something?
IF h2 THEN
  PUSH h2
  ASM call SetFocus
  hObj=h2
ELSE
  IF h1 THEN
    PUSH h1
    ASM call SetFocus
    hObj=h1
  END IF
END IF

TabStopDone:
rec=zero
END SUB

$UNDEF TabHandle, TabOrder, MaxTabReg, VK_SHIFT
