'WinColor.inc Copyright 2007 James J Keene
'updated Mar 8, 2007

'Usage Example: MyRGB = WinColor("Scrollbar")
'where "Scrollbar" is a Windows display component
'as shown in Control Panel > Display > Appearance

declare function WinColor (DispItem as STRING) as LONG

FUNCTION WinColor
dim reg as REGISTRY, i as LONG, v$ as STRING
defint r,g,b
result = zero: r = zero: g = zero: b = zero
reg.RootKey = &H80000001  'HKEY_CURRENT_USER
reg.OpenKey("Control Panel\Colors",0)
IF reg.ValueItemCount THEN
  FOR i=0 to reg.ValueItemCount-one
  v$=reg.ValueItem(i)
  IF reg.Name = DispItem THEN
    r=val(field$(v$,space,1))
    g=val(field$(v$,space,2))
    b=val(field$(v$,space,3))
    EXIT FOR
  END IF
  NEXT i
END IF
reg.CloseKey
i=rgb(r,g,b)
IF NOT i THEN
  showmessage "Display Component not found": exit function
ELSE 
  result = i
END IF
END FUNCTION
