'file_ver.inc Copyright 2008 James J Keene
'updated: Nov 22, 2008

Type VS_FIXEDFILEINFO
  Signature As Long
  StrucVersion As Integer
  FileVersionMSlo As word
  FileVersionMShi As word
  FileVersionLSlo As word
  FileVersionLShi As word
  ProductVersionMS As Integer
  ProductVersionLS As Integer
  FileFlagsMask As Long
  FileFlags As Long
  FileOS As Long
  FileType As Long
  FileSubtype As Long
  FileDateMS As Long
  FileDateLS As Long
End Type

declare function FileVersion (FV_name as string) as string

function FileVersion
begin runonce
  dim Ver As VS_FIXEDFILEINFO
  defstr sBuffer
  Declare Function GetFileVersionInfoSizeA lib "version" _
    (s1 as string, a1 As Long) As Long
  Declare Function GetFileVersionInfoA Lib "Version" _
    (s1 as string, a1 as long, a2 as long, a3 as long) as long
  Declare Function VerQueryValueA Lib "Version" _
    (a1 As long, a2 As long, a3 As long, a4 As Long) As Long
end runonce
defstr fVersion   'initialize result with each call
deflng L1, L2, L3 'scratch variables

'for easy reference,
'we put the verbose arg names before function usage:
'(strFilename As String, lpHandle As Long) As Long
L1 = GetFileVersionInfoSizeA(FV_name,@L2)  'L2 unused dummy
if L1 > zero then        'file has version info!
  sBuffer.initialize L1  'L1 is required buffer size
  L1 = GetFileVersionInfoA(FV_name,zero,L1,@sBuffer)
  if L1 then  'success if not zero!
    '(lpBlock As long, lpSubBlock As long, _
    ' lplpBuffer As long, puLen As Long) As Long
    L1 = VerQueryValueA(@sBuffer, @"\", @L2, @L3)
    memcpy @Ver, L2, sizeof(VS_FIXEDFILEINFO)
    fVersion.append str$(Ver.FileVersionMShi),".",_
      str$(Ver.FileVersionMSlo),".",_
      str$(Ver.FileVersionLShi),".",_
      str$(Ver.FileVersionLSlo)
  end if
end If
sBuffer.clear: result=fVersion
end function
