'get_env.inc Copyright 2007 Armando I. Rivera
'Updated Sep 22, 2007
'tightened up code, and added comments

Declare Function GetEnvironmentStringsA Lib "kernel32" As long
Declare Function FreeEnvironmentStringsA Lib "kernel32" (lpsz As Long) As Long
declare function get_env as string

function get_env
  deflng myptr,ret
  defstr myenv,myptrStr
  myptr=GetEnvironmentStringsA ' access the Environment block and assign a pointer to it to variable myptr
  inc(myptr,len(byref$(myptr))+1) 'bypass garbage strings in first position
  myptrStr=byref$(myptr)    ' get the string at current position

  while len(myptrStr) ' check if string length > zero
    myenv.writeline(myptrStr) ' add string to myenv variable
    inc(myptr,len(myptrStr)+1) ' increment the pointer position
    myptrStr=byref$(myptr) ' get the next Environment string
  wend

  ret=FreeEnvironmentStringsA(myptr) ' free the Environment block
  result=myenv    ' return the complete set of environment variables to caller
end function
