$resource TV_BMP as "TreeView.bmp"
defint f0,f1,i,r,nHnd
defstr fav,fav0,fav1
$define nFavorites 99
dim tHnd(nFavorites) as long,dHnd(9) as long

$include "dirtree.inc"
$include "sortlist.inc"

'get Favorites path
defstr favpath=environ$("userprofile")
favpath.append "\Favorites\"

create book As FORM
  ExStyle=book.ExStyle OR &H88  'tool & topmost
  width=200: height=400
  center
  caption="My Favorites"
  create tv1 as TREEVIEW
    bmp="TV_BMP"
    left=0: top=0
    width=book.clientwidth: height=book.clientheight
    style=self.style or &H280
    onmessage=tv1_select
  end create
end create

declare sub LoadFavorites

SUB LoadFavorites
'get sorted Favorites list
fav=DirTree(favpath,&h37)
fav.position=zero: fav1.clear: f1=favpath.len: inc(f1)
while fav.position<fav.length
fav0=fav.readline
if not instr(fav0,".ini") then fav1.additems mid$(fav0,f1)
end while
fav=SortList(fav1)
'put Favorites in TREEVIEW
tv1.clear
fav.position=zero: nHnd=-1
while fav.position<fav.length
fav0=fav.readline: inc(nHnd)
i=ubound(tHnd,1)
if nHnd>i then iadd(i,100): redim tHnd(i)
f0=tally(fav0,"\"): f1=iadd(f0,1)
fav1=field$(fav0,"\",f1)
r=instr(fav1,".url"): if r then dec(r): fav1=left$(fav1,r)
tv1.insertitem dHnd(f0),fav1
r=retfunc: tHnd(nHnd)=r: dHnd(f1)=r
end while
END SUB

LoadFavorites
book.showmodal
end

'get selected Favorite text
tv1_select:
if uMsg<>&H4E then retval zero: return 'WM_NOTIFY?
if wParam<>tv1.ID then retval zero: return 'OS error if not equal!!
if byref(lParam+8)<>-402 then retval zero: return 'code=TVN_SELCHANGED?
for i=0 to nHnd
r=tHnd(i)
r=tv1.selected(r)
if r then exit for
next i
fav0=fav.item(i): if instr(fav0,".url") then showmessage fav0
return
