'ReplForm.inc Copyright 2004 James J Keene
'Updated: Sep 9, 2004

'This form replaces the REPLACEDIALOG Object which
'is more difficult to implement in an application.

'Include this file after your main form is defined
'and before your FORM .showmodal.

'To display this Replace Dialog, simply use
'repl.visible=true: fred1.focus
'in your main program.

'Pressing enter in the edit boxes or clicking
'"Replace" or "Replace All" runs your "do_replace"
'or "do_replace_all" routines.

'The "repl_hide" routine simply does this:
'repl.visible=false: sc.focus 'set desired focus

create repl as FORM
  ExStyle = repl.ExStyle OR &H88  'tool & topmost
  Caption = "Replace Text"
  Width = 240
  Height = 122
  Center
  Resizeable=false
  Visible=false
  Onclose=repl_hide  'sub setting .visible=false
  create frlab1 As LABEL
    Top=8
    Left=8
    Width=64
    Height=20
    Caption="Find what:"
  end create
  create fred1 As EDIT
    Top=8
    Left=80
    Width=144
    Height=20
    OnKeyUp=fred1_key
  end create
  create frlab2 As LABEL
    Top=40
    Left=8
    Width=64
    Height=20
    Caption="Replace with:"
  end create
  create fred2 As EDIT
    Top=40
    Left=80
    Width=144
    Height=20
    OnKeyUp=fred2_key
  end create
  create frcase As CHECKBOX
    Top=72
    Left=8
    Width=80
    Height=20
    Caption="Match case"
  end create
  create frbut1 As BUTTON
    Top=72
    Left=90
    Width=64
    Height=20
    Caption="Replace"
    OnClick=do_replace  'user-written procedure
  end create
  create frbut2 As BUTTON
    Top=72
    Left=160
    Width=64
    Height=20
    Caption="Replace All"
    OnClick=do_replace_all  'user-written procedure
  end create
end create

Goto ReplForm_End  'jump past this:

fred1_key:
IF wParam=13 THEN Goto do_replace
IF wParam=27 THEN Goto repl_hide
IF wParam=9 THEN fred2.focus
return

fred2_key:
IF wParam=13 THEN Goto do_replace_all
IF wParam=27 THEN Goto repl_hide
IF wParam=9 THEN fred1.focus
return

ReplForm_End:
