'RichEd2.inc Copyright 2004 James J. Keene
'Updated: Mar 31, 2007

'This include extends the HotBasic RICHEDIT2 OBJECT

'$DEFINE CFM_BOLD 1
'$DEFINE CFM_ITALIC 2
'$DEFINE CFM_UNDERLINE 4
'$DEFINE CFM_STRIKEOUT 8
'$DEFINE CFM_PROTECTED 16
'$DEFINE CFM_SIZE   &H80000000
'$DEFINE CFM_COLOR  &H40000000
'$DEFINE CFM_FACE   &H20000000
'$DEFINE CFM_OFFSET &H10000000
'$DEFINE CFM_CHARSET &H8000000

defLNG re2ADDR
defint re2RET
defstr re2STR

OBJECT RichEd2 EXTENDS RICHEDIT2

'CHARRANGE, FINDTEXT and TEXTRANGE:
SelectStart As LONG
SelectEnd As LONG = 4294967295  '-1
TextAddr As LONG

'POINT at offset = 12:
CharX As LONG
CharY As LONG

'CHARFORMAT at offset = 20: 
cbSize As LONG = 60
MaskBits As LONG = 2818572289
Effects As LONG
ChrHeight As LONG
ChrOffset As LONG 
TextColor As LONG
CharSet As BYTE = 1
PitchAndFamily As BYTE = 49
FaceName As STRING*32 = "Fixedsys" 'for code editor
wPad As WORD 

'more properties and methods:
CanPaste As FUNCTION
CanReDo As FUNCTION
CanUnDo As FUNCTION
CharFromLine As FUNCTION
CharFromPos As FUNCTION
CharFormat As SUB
EmptyUndoBuffer As SUB
EventMask As FUNCTION
FirstVisibleLine As FUNCTION
Item As FUNCTION
LineFromChar As FUNCTION
LineLength As FUNCTION
Options As FUNCTION
PosFromChar As SUB
SetCharFormat As SUB
SetEventMask As SUB
SetOptions As SUB
UnDo As SUB
HBcolors As SUB
END RichEd2

Declare FUNCTION CanPaste(uFormat As LONG) As LONG
Declare FUNCTION CanReDo As LONG
Declare FUNCTION CanUnDo As LONG
Declare FUNCTION CharFromLine(re2LINE As LONG) As LONG
Declare FUNCTION CharFromPos(re2x As LONG, re2y As LONG) As LONG
Declare SUB CharFormat
Declare SUB EmptyUndoBuffer
Declare FUNCTION EventMask As LONG
Declare FUNCTION FirstVisibleLine As LONG
Declare FUNCTION Item(re2LINE As LONG) As STRING
Declare FUNCTION LineFromChar(re2POS As LONG) As LONG
Declare FUNCTION LineLength(re2VAL As LONG) As LONG
Declare FUNCTION Options As LONG
Declare SUB PosFromChar(re2POS As LONG)
Declare SUB SetCharFormat
Declare SUB SetEventMask(re2VAL As LONG)
Declare SUB SetOptions(re2HOW As LONG, re2VAL As LONG)
Declare SUB UnDo

FUNCTION CanPaste(uFormat As LONG) As LONG
result=sendmessage(hbHnd,1074,uFormat,zero)
END FUNCTION

FUNCTION CanReDo As LONG
result=sendmessage(hbHnd,1109,zero,zero)
END FUNCTION

FUNCTION CanUnDo As LONG
result=sendmessage(hbHnd,198,zero,zero)
END FUNCTION

'returns char position from line index
FUNCTION CharFromLine(re2LINE As LONG) As LONG
result=sendmessage(hbHnd,187,re2LINE,zero)
END FUNCTION

FUNCTION CharFromPos(re2x As LONG, re2y As LONG) As LONG
re2x=re2x SHL 16 OR re2y
'result low-order word is char index
'result high-order word is line index or -1
result=sendmessage(hbHnd,215,zero,re2x)
END FUNCTION

'gets RichEd2 properties for current selection
SUB CharFormat
re2ADDR=hbObj+20
re2RET=sendmessage(hbHnd,1082,one,re2ADDR)
END SUB

SUB EmptyUndoBuffer
re2RET=sendmessage(hbHnd,205,zero,zero)
END SUB

FUNCTION EventMask As LONG
result=sendmessage(hbHnd,1083,zero,zero)
END FUNCTION

FUNCTION FirstVisibleLine As LONG
result=sendmessage(hbHnd,206,zero,zero)
END FUNCTION

'Returns line from 0-based itemindex
FUNCTION Item(re2LINE As LONG) As STRING
re2STR=STRING$(256,chr$(0))  'note line length limit = 256
BYREF(@re2STR)=256
re2RET=sendmessage(hbHnd,196,re2LINE,@re2STR)
IF re2RET THEN result=left$(re2STR,re2RET-one) ELSE result=null
END FUNCTION

'returns line index from char position
'.ItemIndex returns index of line with caret
FUNCTION LineFromChar(re2POS As LONG) As LONG
result=sendmessage(hbHnd,1078,zero,re2POS)
END FUNCTION

'returns line length from char position
FUNCTION LineLength(re2POS As LONG) As LONG
result=sendmessage(hbHnd,193,re2POS,zero)
END FUNCTION

FUNCTION Options As LONG
result=sendmessage(hbHnd,1102,zero,zero)
END FUNCTION

'sets .CharX and CharY based on CharPos
SUB PosFromChar(re2POS As LONG)
re2ADDR=hbObj+12
re2RET=sendmessage(hbHnd,214,re2ADDR,re2POS)
END SUB

'use RichEd2 properties for current selection
SUB SetCharFormat
re2ADDR=hbObj+20
re2RET=sendmessage(hbHnd,1092,3,re2ADDR)
END SUB

SUB SetEventMask(re2VAL As LONG)
re2RET=sendmessage(hbHnd,1093,zero,re2VAL)
END SUB

SUB SetOptions(re2HOW As LONG, re2VAL As LONG)
re2RET=sendmessage(hbHnd,1101,re2HOW,re2VAL)
END SUB

SUB UnDo
re2RET=sendmessage(hbHnd,199,zero,zero)
END SUB

$include "HBColors.inc"
