'UTF8.inc Copyright 2006 James J Keene
'Updated: Apr 20, 2006

'based on RFC 3629

'AscFromUTF8 converts a UTF-8 string to ASCIIZ
'UTF8FromAsc converts an ASCIIZ string to UTF-8

DECLARE FUNCTION AscFromUTF8(utf8str as STRING) As STRING
DECLARE FUNCTION UTF8FromAsc(ascstr as STRING) As STRING

FUNCTION AscFromUTF8
DEFSTR r$  'sets r$=null on entry
DEFINT i, j, k
DEFBYTE b1,  b2
for i=1 to utf8str.length step 1
k=asc(utf8str[i]): b1=k
IF k > &HC3 THEN goto bad_utf8
IF k and &H80 THEN   
  j=(k and &H3)*64: inc(i): k=asc(utf8str[i])
  IF k and &H80 THEN
    b2=j+(k and &H3F): r$.write(b2)
  ELSE
    goto bad_utf8
  END IF
ELSE
  r$.write(b1)
END IF
next i
goto u2a_done
bad_utf8:
showmessage "Invalid UTF8 string"
u2a_done:
RESULT=r$
END FUNCTION

FUNCTION UTF8FromAsc
DEFSTR r$  'sets r$=null on entry
DEFINT i, k
DEFBYTE b1, b2
for i=1 to ascstr.length
k=asc(ascstr[i]): b1=k
IF k and &H80 THEN
  b2 = k\64 OR &HC0: r$.write(b2)
  b1 = k AND &H3F OR &H80: r$.write(b1)
ELSE
  r$.write(b1)
END IF
next i
RESULT=r$
END FUNCTION
