$APPTYPE CONSOLE
$include "cpuid.inc"

dim cpu as cpuid

color 15,0
PRINT "HotBasic CPUID Object examines your machine!"
color 7,0
print "cpu.HighestParameter = "; cpu.HighestParameter
print "cpu.VenderID         = "; cpu.VenderID
print "cpu.Stepping         = "; cpu.Stepping
print "cpu.Model            = "; cpu.Model
print "cpu.Family           = "; cpu.Family
print "cpu.Type             = "; cpu.Type
print "cpu.ExtModel         = "; cpu.ExtModel
print "cpu.ExtFamily        = "; cpu.ExtFamily
print "cpu.BrandID          = "; cpu.BrandID
print "cpu.CLFlush          = "; cpu.CLFlush
print "cpu.CPUCount         = "; cpu.CPUCount
print "cpu.APIC_ID          = "; cpu.APIC_ID
print "cpu.Feature3 (ECX)   = "; hex$(cpu.Feature3)
print "cpu.Feature4 (EDX)   = "; hex$(cpu.Feature4)
'print "cpu.Config1  (EAX)   = "; hex$(cpu.Config1)
'print "cpu.Config2  (EBX)   = "; hex$(cpu.Config2)
'print "cpu.Config3  (EDX)   = "; hex$(cpu.Config3)
'print "cpu.Config4  (ECX)   = "; hex$(cpu.Config4)
'pause
print "cpu.HighestExtended  = "; hex$(cpu.HighestExtended)
print "cpu.Extended1        = "; hex$(cpu.Extended1)
print "cpu.Extended2        = "; hex$(cpu.Extended2)
print "cpu.Extended3        = "; hex$(cpu.Extended3)
print "cpu.Extended4        = "; hex$(cpu.Extended4)
print "cpu.Brand            = "; cpu.Brand
print "cpu.DataL1SizeKB     = "; cpu.DataL1SizeKB
print "cpu.CodeL1SizeKB     = "; cpu.CodeL1SizeKB
pause
PRINT
color 15,0
PRINT "Note:"
PRINT "Please see CPUID.inc for the full list of CPUID members"
PRINT "and a link to a quite thorough reference."
color 7,0
PAUSE
END
