'hLISTBOX.inc Copyright 2006 James J Keene
'updated: Feb 7, 2007

'Requires justify.inc.  In main program, do
'$include "justify.inc"
'$include "hLISTBOX.inc"

OBJECT hLISTBOX EXTENDS LIST
Title as String*80 = "HotBasic hLISTBOX Custom Object"
Left as long = 1
Top as long = 1
Width as long = 40
Height as long = 24
Center as long
View as long
Indent as long = 1
TitleColor as long
TitleBkgColor as long = 11
Color as long = 15
BkgColor as long = 1
CurColor as long
CurBgkColor as long = 2
SelColor as long = 13
SelBgkColor as long = 1
Cursor as long = 1
CursorLast as long = 1
Focus as long
Visible as long = 1
Enabled as long = 1
Selected as long = -1
TopItem as long
TopLast as long
Lines as long
Hide as SUB
Show as SUB
END hLISTBOX

declare sub HLISTBOXShow
declare sub HLISTBOXHide
declare sub HLISTBOXPrint (hLB$ as STRING, hLBw as LONG)

sub HLISTBOXShow
begin runonce: defstr t$: end runonce
defint i,j,k,n,left,top,width,height
if not self.Visible then exit sub
top=self.Top: left=self.Left
height=self.Height: width=self.Width
'title bar
k=@HLISTBOX.TitleColor: gosub LBSet_Color
locate top, left
t$=self.Title
HLISTBOXPrint t$, width
'print items
k=@HLISTBOX.Color: gosub LBSet_Color
j=self.TopItem
k=self.Lines
if self.Cursor>k then self.Cursor=k
'use xLIST as LIST with hbHnd
'end use xLIST
for i = 1 to height
n=i+j
if i=self.Cursor and self.Focus=true then k=@HLISTBOX.CurColor: gosub LBSet_Color
locate top+i, left
if n>k then
  t$=space$(width-self.Indent)
else
'  t$=field$(xLIST,crlf,n)  '.item(n)
  asm mov ebx,hbHnd
  asm push [ebx+4]: asm push [ebx]
  asm push 2: asm lea esi,hbCrLf: asm push esi
  push n
  asm call hFIELD$
  asm invoke bufassign,esi,ADDR HLISTBOXShowt$,ecx
end if
HLISTBOXPrint t$, width
if i=self.Cursor and self.Focus=true then
  k=@HLISTBOX.Color: gosub LBSet_Color
end if
next i
color 7,0: self.Visible=true
end sub

'sub HLISTBOXHide
'defint i,j,w
'color 7,0
'j=self.Top: w=self.Width
'for i = j to j+self.Height
'locate i, self.Left
'print space$(w);
'next i
'self.Visible=false
'locate 24,1: color 7,0
'end sub

sub HLISTBOXPrint
defint i = self.Indent
defint j = (hLBw-i)-hLB$.Length
if i then print space$(i);
if self.Center then
  print JustCenter(hLB$,hLBw);: exit sub
end if
if j < zero then
  if self.View then goto Left_Just
  print "..."; right$(hLB$,hLBw-(3+i));
else
  Left_Just:
  print left$(hLB$,hLBw);
  if j > zero then print space$(j);
end if
end sub

goto End_hLISTBOX

LBSet_Color:
color byref(HLISTBOXShowk), byref(HLISTBOXShowk+4)
return

End_hLISTBOX:
