$APPTYPE CONSOLE: $TYPECHECK ON
$include "index.inc"

defreal10 t: defint i,j,k: defstr r$

dim d as LIST
dim dindex as INDEX

next_file:
cls
color 15: PRINT "HotBasic INDEX Object Miracle": color 14
print
input "Big text/list file to load and test: "; r$
if not r$.length then app.terminate

d.loadfromfile r$

dindex.Init Objptr(d)

defint n = d.itemcount-one

color 10: PRINT "Random access test:": color 7
randomize timer
for j=1 to 9: i=rnd(n)
r$=d.item(i): print r$
r$=dindex.Item(i): print r$
next j
pause: print

color 10: PRINT ".AddItems test:": color 7
d.AddItems "INDEX Miracle": dindex.AddItems
inc(n)  'itemcount-one
r$=d.item(n): print r$
r$=dindex.Item(n): print r$
d.AddItems "gives huge access speed increase": dindex.AddItems
inc(n)  'itemcount-one
r$=d.item(n): print r$
r$=dindex.Item(n): print r$
print

color 10: PRINT "Access time test:": color 11
k=1000000/d.length 'iterations proportional to length
if not k then k=1  '> 1 meg is 1 iteration
t=timer
for j=1 to k
for i=0 to n: r$=dindex.Item(i): next i
next j
t=timer-t
print "For LIST with 0 to "; n; " items,"
print "using INDEX .Item() took "; t; " seconds."
print

t=timer
for j=1 to k
for i=0 to n: r$=d.item(i): next i
next j
t=timer-t
print "For LIST with 0 to "; n; " items,"
print "using native .Item() took "; t; " seconds."
print

color 7: PAUSE
goto next_file
END
