'Index.inc Copyright 2006 James J Keene
'Updated: Nov 26, 2006

OBJECT INDEX EXTENDS MEMORY
  ListPtr as LONG
  Init As SUB
  AddItems As SUB
  Item as FUNCTION
END INDEX

declare sub INDEXInit (ListPtr as LONG)
declare sub INDEXAddItems
declare function INDEXItem (Index as LONG) As STRING

sub INDEXInit
defint i, j
defstr r$
self.ListPtr=ListPtr
use iLIST as LIST with ListPtr
use iMEM as MEMORY with hbHnd
i=4*iLIST.itemcount: iMEM.Initialize i
iMEM.Position=4  '1st index pointer is always zero
'get the remaining index pointers
iLIST.Position=zero
for j=1 to iLIST.itemcount
r$=iLIST.ReadLine
i=iLIST.Position: iMEM.Write(i)
next j
end use iMEM
end use iLIST
end sub

sub INDEXAddItems
defint i
i=self.ListPtr: i=byref(i+8) 'get new LIST length
use iMEM as MEMORY with hbHnd
iMEM.Write(i)
end use iMEM
end sub

function INDEXItem
use iLIST as LIST with self.ListPtr
asm mov ebx,Index: asm shl ebx,2     '4*Index
asm mov eax,hbHnd: asm mov eax,[eax] 'MEMORY pointer
asm add eax,ebx: asm mov eax,[eax]   'add offset; get pointer
iLIST.Position=retfunc  'item pointer
result=iLIST.ReadLine
iLIST.Position=iLIST.Length  'so .AddItems will work
end use iLIST
end function
