$APPTYPE CONSOLE: $TYPECHECK ON
$INCLUDE "profile.inc"

defint iter, n = 100000
defstr k$

k$ = "HotBasic PROFILE Object Test"
color 15: print k$: color 7: print

dim p1 as PROFILE, p2 as PROFILE, p3 as PROFILE
p1.Init: p2.Init: p3.Init

'uncomment to save results to file
'p1.WriteFile=true: p2.WriteFile=true: p3.WriteFile=true

'BEGIN any common code
'
'for SELECTED NUMERIC FUNCTIONS
p1.Name="Num"
defdbl x,y = 0.5

'for SELECTED STRING FUNCTIONS
p2.Name="Str"
defstr a$,b$=" 1 2 3 4 5 6 7 8 9 0 "

'for SELECTED TYPE CONVERSIONS
p3.Name="Conv"
defbyte b = 100
defword w = 100
defint i = 100
defsng s = 100.0
defdbl d = 100.0
defstr c$

'END any common code

for iter=one to n
'BEGIN Test Code

'=====SELECTED NUMERIC FUNCTIONS
p1.Start
x=acos(y)
x=asin(y)
x=atan(y)
x=cos(y)
x=exp(y)
x=log(y)
x=sin(y)
x=sqr(y)
x=tan(y)
p1.Stop

'=====SELECTED STRING FUNCTIONS
p2.Start
a$=chr$(65)
a$=comma  'same as a$=","
a$=delete$(b$,5,2)
a$=field$(b$,space,5)
a$=hex$(1024)
a$=insert$(b$,"A",5)
a$=lcase$(b$)
a$=left$(b$,5)
a$=ltrim$(b$)
a$=mid$(b$,5,2)
a$=null   'same as a$=""
a$=quote  'same as a$=chr$(34)
a$=replace$(b$,"A",5)
a$=replacesubstr$(b$,"5","A")
a$=reverse$(b$)
a$=right$(b$,5)
a$=rtrim$(b$)
a$=space  'same as a$=" "
a$=space$(20)
a$=str$(3.14)
a$=string$(20,".")
a$=tab  'same as a$=chr$(9)
a$=trim$(b$)  'same as a$=rtrim$(ltrim$(b$))
a$=ucase$(b$)
a$=wide$(b$)
a$.write(b$)  'fast version of a$=a$+b$
a$="Hot"&"Basic"  'ordinary concatenation
p2.Stop

'=====SELECTED TYPE CONVERSIONS, b,w,i,s,d
'HotBasic does these automatically
'without calls to "conversion functions"
p3.Start
b=w: b=i: b=s: b=d
w=b: w=i: w=s: w=d
i=b: i=w: i=s: i=d
s=b: s=w: s=i: s=d
d=b: d=w: d=i: d=s
d=val("3.14")  'string to double conversion
c$=str$(d)     'double to string conversion
i=val("10")    'string to integer conversion
c$=str$(i)     'integer to string conversion
p3.Stop

'END Test Code
next iter

p1.Report: p2.Report: p3.Report

PAUSE
END
