'sblabels.inc Copyright 2008 James J Keene
'Updated: Aug 20, 2008

'Include this file after optional DIM/CREATE of a STATUSBAR

$DEFINE SB_LABEL_HEIGHT 14

DefInt nPanel, iPanel, mPanel, ePanel
'edit to your number of panels
nPanel = 6  '0-Based number of panels

OBJECT SBLABELS
First as long  'base subscript for instance
Last as long
Panel as sub
SetParts as sub
Text as sub
END SBLABELS

'Panel is 0-Based index for statusbar panel

Declare SUB SBLABELS_Init
Declare SUB SBLABELSPanel (Panel As LONG, pWidth As LONG)
Declare SUB SBLABELSSetParts
Declare SUB SBLABELSText (Panel As LONG, pText As STRING)

goto SB_Subs

SB_DIM:  'dim here so names are not local to formal SUB
DIM SB_Panel(nPanel) As LONG
DIM SB_Label(nPanel) As LABEL
return

SB_Subs:

SUB SBLABELS_Init
begin runonce
gosub SB_DIM
mPanel=-1
for iPanel=0 to nPanel
SB_Label(iPanel).top=-SB_LABEL_HEIGHT 'put off-screen
SB_Label(iPanel).height=SB_LABEL_HEIGHT
SB_Label(iPanel).visible=false
next iPanel
end runonce
inc(mPanel): self.First=mPanel
END SUB

'First, set your panel widths
'and instance's number (range) of panels
SUB SBLABELSPanel(Panel As LONG, pWidth As LONG)
SB_Panel(Panel) = pWidth
SB_Label(Panel).width=pWidth
if Panel>self.Last then self.Last=Panel: mPanel=Panel
END SUB

'Second, calculate offsets based on widths
'If you change a width, call SetParts again

SUB SBLABELSSetParts
ePanel = 2: self.Last=mPanel
for iPanel=self.First to self.Last
SB_Label(iPanel).left=ePanel
SB_Label(iPanel).top=_
  window(hbParent).clientheight-2-SB_LABEL_HEIGHT 
SB_Label(iPanel).visible=true
SB_Label(iPanel).color=&HFFFFFF  'white
IADD(ePanel,3)
ePanel = ePanel + SB_Panel(iPanel)
next iPanel
END SUB

'Third, at any time, set panel text

SUB SBLABELSText(Panel As LONG, pText As STRING)
SB_Label(Panel).caption=pText: DOEVENTS
END SUB

$UNDEF SB_LABEL_HEIGHT
